* CORE Application Program Interface
*--------------------------------------------------------------------------------------
PROCEDURE SystemDirectory
***
* Input   > M.xioSysDir;
* Output  > M.xoReturn;
* Purpose > Ricava la Directory di Sistema del Sistema Operativo Corrente.
***
* SECTION COMMUNICATION
PARAMETERS M.xioSysDir, M.xoReturn

* SECTION API DEFINITION
_GetSystemDirectory=REGFN("GetSystemDirectory","@CI","I")

* SECTION SERVICE
PRIVATE M.IOBuffer, M.IOBLength, M.ReturnInfo
M.IOBuffer   = SPACE(200)
M.IOBLength  = 200

* AREA INTELLIGENCE
M.xoReturn  =CALLFN(_GetSystemDirectory,@M.IOBuffer,M.IOBLength)
M.xioSysDir =ALLTRIM(M.IOBuffer)
*
RETURN
*--------------------------------------------------------------------------------------
FUNCTION API_IsActive (M.xiWinTitle)
***
* Purpose > Controlla se la Finestra specificata  gi attiva.
***

* SECTION SERVICE
LOCAL M.xo_Return, M.API_Return
M.xo_Return  = .F.
M.API_Return = 0

* SECTION API DEFINITION
_GetWind=REGFN("FindWindow","CC","I")

* SECTION SERVICE
PRIVATE M.WClass
M.WClass   = 0

* AREA INTELLIGENCE
M.xiWinTitle  = ALLTRIM(M.xiWinTitle)
M.API_Return  = CALLFN(_GetWind,M.WClass,M.xiWinTitle)
M.xo_Return   = ( M.API_Return <> 0 )
*
RETURN M.xo_Return
*--------------------------------------------------------------------------------------
