
*-- area communication
    lparameters m.xiPbls_rif, m.xiProtocollo
    

    
*-- area service


    public m.w001_code as Integer
    public m.w001_desc as Integer
    m.w001_code = 0
    m.w001_desc = ""
    
    public m.w002_code as Integer
    public m.w002_desc as Integer
    m.w002_code = 0
    m.w002_desc = ""    
    
    public m.w003_code as Integer
    public m.w003_desc as Integer
    m.w003_code = 0
    m.w003_desc = ""    

    public m.w004_code as Integer
    public m.w004_desc as Integer
    m.w004_code = 0
    m.w004_desc = ""    
    
    
    public m.w005_code as Integer
    public m.w005_desc as Integer
    m.w005_code = 0
    m.w005_desc = "" 
       
    public m.c001_code as Integer
    public m.c001_desc as Integer
    m.c001_code = 0
    m.c001_desc = ""
            
    public m.c002_code as Integer
    public m.c002_desc as Integer
    m.c002_code = 0
    m.c002_desc = ""

    public m.c003_code as Integer
    public m.c003_desc as Integer
    m.c003_code = 0
    m.c003_desc = ""    


    public m.c004_code as Integer
    public m.c004_desc as Integer
    m.c004_code = 0
    m.c004_desc = ""    

    public m.c005_code as Integer
    public m.c005_desc as Integer
    m.c005_code = 0
    m.c005_desc = ""    

    public m.c006_code as Integer
    public m.c006_desc as Integer
    m.c006_code = 0
    m.c006_desc = ""    

    public m.c007_code as Integer
    public m.c007_desc as Integer
    m.c007_code = 0
    m.c007_desc = ""    

    public m.c008_code as Integer
    public m.c008_desc as Integer
    m.c008_code = 0
    m.c008_desc = ""    

    public m.c009_code as Integer
    public m.c009_desc as Integer
    m.c009_code = 0
    m.c009_desc = ""    

    public m.c010_code as Integer
    public m.c010_desc as Integer
    m.c010_code = 0
    m.c010_desc = ""    

    public m.c011_code as Integer
    public m.c011_desc as Integer
    m.c011_code = 0
    m.c011_desc = ""    

    public m.c012_code as Integer
    public m.c012_desc as Integer
    m.c012_code = 0
    m.c012_desc = ""    

    public m.c012_code as Integer
    public m.c012_desc as Integer
    m.c012_code = 0
    m.c012_desc = ""    

    public m.c013_code as Integer
    public m.c013_desc as Integer
    m.c013_code = 0
    m.c013_desc = ""        

    public m.c014_code as Integer
    public m.c014_desc as Integer
    m.c014_code = 0
    m.c014_desc = ""  
          
    public m.c015_code as Integer
    public m.c015_desc as Integer
    m.c015_code = 0
    m.c015_desc = ""   
         
    public m.c016_code as Integer
    public m.c016_desc as Integer
    m.c016_code = 0
    m.c016_desc = ""        

*-- area intelligence

    *-- Set Up cache folder
	    public m.PathFolderCache as String
	    m.PathFolderCache = m.GS_LRP+"cache\"+alltrim(m.gs_pbls_des)+"\" 
	    =MKDIR(JUSTPATH(ALLTRIM(m.PathFolderCache)))


    
    *-- Entity Positioning
	    select epublist
	    locate for epublist.pbls_ide = m.xiPbls_rif 
	    if ( not found("epublist") ) then
	       return ""
	    endif 
	    
	    select tdomanda
	    locate for tdomanda.pbls_rif   = m.xiPbls_rif  ;
	           and tdomanda.protocollo = m.xiProtocollo 
	    if not found("tdomanda") then
	       return ""
	    endif
 	    
    *-- Controllo se Decennali o Novennali
        if upper(alltrim(tdomanda.em))=="E" then
           do case
              case "A"$upper(alltrim(tdomanda.qualifica)) ;
                or "B"$upper(alltrim(tdomanda.qualifica)) 
                   if ( year(date()) - year(tdomanda.dataestero)) > 8 then
					    m.c016_code = 30
					    m.c016_desc = "Decennale: non pu fare domanda !!!"        
					    return                       
                   endif
                          
              case "C"$upper(alltrim(tdomanda.qualifica)) 
                   if ( year(date()) - year(tdomanda.dataestero)) > 7 then
					    m.c016_code = 30
					    m.c016_desc = "Novennale: non pu fare domanda !!!"                           
					    return
                   endif

           endcase
           
        endif
        
        if used("lsr") then
           select lsr
           use
        endif
        
	    select *        ;
	      from tdposto  ;
	     where ( not deleted("tdposto"))           ; 
	       and tdposto.Pbls_rif   = m.xiPbls_rif   ;
	       and tdposto.protocollo = m.xiProtocollo ; 
	    into table (alltrim(m.PathFolderCache)+"lsr.dbf")
        
        if reccount("lsr") = 0 then
		   m.c009_code = 19
		   m.c009_desc = "La domanda non contiene richieste di posti!!!"
        endif        

      
    *-- Ricongiungimento: Pu chiedere una sede secca
        if tdomanda.cric = 1 then
           return
        endif


        if used("ldsr") then
           select ldsr
           use
        endif
        
        select *            ;
          from trlist       ;
         where ( not deleted("trlist") )      ;
           and trlist.pbls_rif = m.xiPbls_rif ;
           and trlist.nsedia in               ;
               ( select lsr.nsedia from lsr where lsr.sricev = 1 )  ;
	    into table (alltrim(m.PathFolderCache)+"ldsr.dbf")
        
        if reccount("ldsr")=0 then
		   m.c014_code = 24
		   m.c014_desc = "Le candidature specificate sono tutte NEGATIVE"
        endif

    
    
    
    *-- Check se le sedi sono appropriate
        if used("lsr_neg") then
           select lsr_neg
           use
        endif
    
        select *   ;
          from lsr ;
         where upper(alltrim(lsr.prel))=="NEG" ;
        into table (alltrim(m.PathFolderCache)+"lsr_neg.dbf") 
        
        if reccount("lsr_neg") > 0 then  
		   m.w003_code = 3
		   m.w003_desc = "L'elenco delle sedi richieste contiene n."+alltrim(str(reccount("lsr_neg")))+" NON APPROPRIATE."
        endif



               
    *-- Check se le sedi sono NON Ricevibili 
        if used("lsr_ric") then
           select lsr_ric
           use
        endif    
        
        select *   ;
          from lsr ;
         where lsr.sricev = 0 ;
        into table (alltrim(m.PathFolderCache)+"lsr_ric.dbf")  
        
        if reccount("lsr_ric") > 0 then  
		   m.c001_code = 10
		   m.c001_desc = "L'elenco delle sedi richieste contiene n."+alltrim(str(reccount("lsr_ric")))+" NON RICEVIBILI."
        endif
        
        
        
    *-- Check al Max due sedi per paese
        if used("cNSPaese") then
           select cNSPaese
           use
        endif    
        if used("cGNSPaese") then
           select cGNSPaese
           use
        endif    

        select distinct * ;
          from trlist       ;
         where ( not deleted("trlist") )      ;
           and trlist.pbls_rif = m.xiPbls_rif ;
           and trlist.nsedia in               ;
               ( select distinct ldsr.nsedia from ldsr where ldsr.diffcop = 0 and ldsr.bellica = 0 )  ;
         into table (alltrim(m.PathFolderCache)+"cNSPaese.dbf")
        
        select cNSPaese.paese ;
          from cNSPaese ;
         group by cNSPaese.paese ;
         having count(*) > 2     ;
        into table (alltrim(m.PathFolderCache)+"cGNSPaese.dbf")
    
        
        select cGNSPaese
        go top
        scan
           
		   m.c002_code = 11
		   m.c002_desc = alltrim(m.c002_desc)+" "+alltrim(cGNSPaese.paese)+"/"
           
           select cGNSPaese
        endscan
        
        if m.c002_code = 11 then    
           m.c002_desc = "Per "+m.c002_desc+" sono state specificate pi di due sedi."
        endif
        
        
        
    

    *-- Miniamo Sedi in base Lingue
        local m.zx_msbl as Integer
        m.zx_msbl = tdomanda.nslng01
        if ( m.zx_msbl < tdomanda.nslng02 ) then
           m.zx_msbl = tdomanda.nslng02
        endif
        if ( m.zx_msbl < tdomanda.nslng03 ) then
           m.zx_msbl = tdomanda.nslng03
        endif
        if ( m.zx_msbl < tdomanda.nslng04 ) then
           m.zx_msbl = tdomanda.nslng04
        endif
        if ( m.zx_msbl < tdomanda.nslng05 ) then
           m.zx_msbl = tdomanda.nslng05
        endif
        if ( m.zx_msbl < tdomanda.nslng06 ) then
           m.zx_msbl = tdomanda.nslng06
        endif

	    m.w002_code = 01
	    m.w002_desc = "Il max numero di sedi in base al Posto Funzione e alle lingue scelte  "+alltrim(str(m.zx_msbl))+"."
        

    
    *-- Minimo Sedi
        local m.zx_n  as Integer
        local m.zx_d  as Integer
        local m.zx_pd as Integer
        local m.zx_dc as Integer
        local m.zx_b  as Integer

        m.zx_n  = 0
        m.zx_d  = 0
        m.zx_pd = 0
        m.zx_dc = 0
        m.zx_b  = 0
               	       
        select ldsr
        go top
        scan
           
            if ( ldsr.bellica = 1 )  then
               m.zx_b = m.zx_b + 1
            else
            
               if ( ldsr.diffcop = 1 )  then
                  m.zx_dc = m.zx_dc + 1
               else
            
                  do case
                     case upper(alltrim(ldsr.disagio))=="N"
                          m.zx_n = m.zx_n+1
                     case upper(alltrim(ldsr.disagio))=="D"
                          m.zx_d = m.zx_d+1
                          
                     case upper(alltrim(ldsr.disagio))=="PD"
                          m.zx_pd = m.zx_pd+1
                          
                  endcase
                  
               endif
            endif
            
		    select ldsr
        endscan
        
        *wait window str(m.zx_pd)
        
        
        *-- Dati della Domanda per individuare il vincolo

            local m.zx_tggmae as integer
            m.zx_tggmae = tdomanda.tggmae

	        local m.zx_ppcode as Integer
	        m.zx_ppcode = tdomanda.ppcode
	        
	        local m.zx_qualifica as String
	        m.zx_qualifica = upper(alltrim(tdomanda.qualifica))
            
*!*	            wait window "gg mae"+str(tdomanda.tggmae)
*!*	            wait window "codice int lista"+str(m.xiPbls_rif)
*!*	            wait window "ppcode"+str(m.zx_ppcode)
*!*	            wait window "qualifica"+alltrim(m.zx_qualifica)
            
        *-- Get constraints
	        if used("cvnms") then
	           select cvnms
	           use
	        endif
            select vincnms
            set order to 
            
	        select * ;
	          from vincnms ;
	         where ( not deleted("vincnms") )                         ;
	           and vincnms.pbls_rif = m.xiPbls_rif                    ;
	           and vincnms.ppcode   = m.zx_ppcode                     ;
	           and upper(alltrim(vincnms.qualifica))== m.zx_qualifica ;
	           and between(m.zx_tggmae,vincnms.pmggda,vincnms.pmgga ) ;
	        into table (alltrim(m.PathFolderCache)+"cvnms.dbf")   	           
        
        
	        if  ( not reccount("cvnms") = 0 ) then
		        select cvnms
		        go top
	            	        
		        if ( m.zx_msbl >= cvnms.nmsedi) then
		        
			        select cvnms
			        go top
			        if ( reccount("ldsr") < cvnms.nmsedi ) then
			           m.c004_code = 13 
			           m.c004_desc = "Non  stato specificato il minimo totale delle Sedi."
			        endif
			        
			        *-- Sedi Normali
				        if ( m.zx_n < cvnms.nm_sn and cvnms.nm_sn > 0 ) then
				           m.c005_code = 14    
				           m.c005_desc = "Non  stato specificato il minimo di Sedi Normali."
				        endif
				        
*!*					        if ( m.zx_n > 0 and cvnms.sn = 0 ) then
*!*					           m.c012_code = 21    
*!*					           m.c012_desc = "Non  possibile specificare Sedi Normali."
*!*					        endif

			        *-- Sedi Disagate			        
				        if ( m.zx_d < cvnms.nm_sd and cvnms.nm_sd > 0 ) then
				           m.c006_code = 15    
				           m.c006_desc = "Non  stato specificato il minimo di Sedi Disagiate."
				        endif
*!*					        if ( m.zx_d > 0 and cvnms.sd = 0 ) then
*!*					           m.c012_code = 22    
*!*					           m.c012_desc = "Non  possibile specificare Sedi Disagiate."
*!*					        endif

			        *-- Sedi Particolarmente Disagiate
				        if ( m.zx_pd < cvnms.nm_spd and cvnms.nm_spd > 0 ) then
				           m.c007_code = 16    
				           m.c007_desc = "Non  stato specificato il minimo di Sedi Particolarmente Disagiate."
				        endif
*!*					        if ( m.zx_pd > 0 and cvnms.spd = 0 ) then
*!*					           m.c013_code = 23    
*!*					           m.c013_desc = "Non  possibile specificare Sedi Particolarmente Disagiate."
*!*					        endif
				        
			        if  (epublist.drequisiti-tdomanda.druolimae) < (365*5) then
				        if ( (m.zx_dc+m.zx_b) < cvnms.nm_sdc and cvnms.nm_sdc > 0 ) then			        
				           m.c008_code = 17    
				           m.c008_desc = "Non  stato specificato il minimo di Sedi Difficile Copertura."			           
				        endif
				    endif    
			        
			        
			    else
			    
			        if ( reccount("ldsr") < m.zx_msbl ) then
			           m.c004_code = 25 
			           m.c004_desc = "Non  stato specificato il minimo totale delle Sedi rispetto alla LINGUA/E conosciuta/e." 
			        else			    
					    m.w002_code = 02
					    m.w002_desc = "I vincoli per Numero Sedi non sono stati considerati in quanto il numero di posti relativi alle lingue specificate non sono congruenti."
			        endif
				    
			    endif
		    else
	           m.c009_code = 18    
	           m.c009_desc = "Vincolo relativo al Posto Funzione NON Presente"
	        endif
        
        
        *-- Il Minimo Sedi rispettato annulla Posti Non Ricevibili 
	        if ( m.c004_code + m.c005_code + m.c006_code + m.c007_code + m.c008_code ) = 0 then
	        
			   m.c001_code = 0
			   m.c001_desc = ""
			   
			   m.w004_code = 4
			   m.w004_desc = "L'elenco delle sedi richieste contiene n."+alltrim(str(reccount("lsr_ric")))+" NON RICEVIBILI."
	        endif 
  
  
  
    *-- Anzianit < 5 anni -> 2 >= (DC+B) Controllo se minimo sede compatibile
        if  .f. then
	        if cvnms.nm_sdc   >= 2 then 
		        if ((epublist.drequisiti-tdomanda.druolimae) < (365*5)) then
		           
		           *-- Get Constraint for DC and B
		               local m.DCBLimit as Integer
		               m.DCBLimit   = 0
		               m.srv_ppcode = tdomanda.ppcode	  
		                            
		               select trlist.ppcode ;
		                 from trlist        ;
		                where ( not deleted("trlist") )      ;
		                  and trlist.pbls_rif = m.xiPbls_rif ;
		                  and trlist.diffcop  = 1            ;
		                  and trlist.ppcode   = m.srv_ppcode ;
		               into cursor cDCB   
		               if reccount("cDCB") < 2 then
		                  m.DCBLimit = reccount("cDCB")
		               else
		                  m.DCBLimit = 2
		               endif
		           
		        
		            local m.zx_dcb as Integer
		            m.zx_dcb = 0
		           	       
			        select ldsr
			        go top
			        scan
			            if ( ldsr.bellica = 1 ) or ( ldsr.diffcop= 1 ) then
			               m.zx_dcb = m.zx_dcb + 1
			            endif
			            
					    select ldsr
			        endscan
			        
			        if (  m.zx_dcb < m.DCBLimit ) then
			           m.c003_code = 12    
			           m.c003_desc = "Sono state specificate meno di due sedi DC/B per un anzianit di servizio minore di 5 anni"
			        endif
			        
		         endif
	        endif
     endif
        
*-- 67 Anno di Et 
    local m.zx_eta as Integer
    m.zx_eta = GetFromHumanAge(tdomanda.dnascita,epublist.drequisiti) 
    *wait window alltrim(str(m.zx_eta))
    if ( m.zx_eta > 65 )   
       m.c010_code = 19    
       m.c010_desc = "Domanda non ricevibile in quanto sono stati oltrepassati i limiti di et."
       
    else
       *-- Ha 64,65 anni e ha chiesto Biennio.
       if (inlist(m.zx_eta,64,65)) and ( tdomanda.chb=1 ) then
       
          if  ( not m.zx_n  = 0 ) then
			   m.w005_code = 5
			   m.w005_desc = "Ha chiesto "+alltrim(str(m.zx_n))+" Sedi Normali. Non pu chiedere Sedi Normali per limiti di et."   
			   
		       m.c011_code = 20    
		       m.c011_desc = "Non pu chiedere sedi normali per limiti di et."              
          endif           
          
       endif
    endif
    
    
     


