* INFORMATION RETRIVAL SUB-SYSTEM
*--------------------------------------------------------------------------------------------------------------------------
procedure PrintFiduciario


*-- section service
    local   ;
    m.wwfcognome,  ;
    m.wwfnome,     ;
    m.wwcodice,    ;
    m.wwragsoc,    ;
    m.wwprofessio, ;
    m.wwspecializ, ;
    m.wwnialbo,    ;
    m.wwcodfisc,   ;
    m.wwpiva,      ;
    m.wwdug,       ;
    m.wwlocalita,  ;
    m.wwnc,        ;
    m.wwcap,       ;
    m.wwcomune,    ;
    m.wwprov,      ;
    m.wwnaz_dsc,   ;
    m.wwtelefono,  ;
    m.wwcellulare, ;
    m.wwtelefax,   ;
    m.wwemail,     ;
    m.wwrtitolo,   ;
    m.wwrcognome,  ;
    m.wwrnome,     ;
    m.wwfunzione,  ;
    m.wwbanca,     ;
    m.wwcab,       ;
    m.wwabi,       ;
    m.wwcc,        ;
    m.wwpm01,      ;
    m.wwpm02,      ;
    m.wwpm03,      ;
    m.wwpm04,      ;
    m.wwpm05,      ;
    m.wwpm06,      ;    
    m.wwpp01,      ;
    m.wwpp02,      ;
    m.wwpp03,      ;
    m.wwpp04,      ;
    m.wwpp05,      ;
    m.wwpp06,      ;    
    m.wwtm01,      ;
    m.wwtm02,      ;
    m.wwtm03,      ;
    m.wwtm04,      ;
    m.wwtm05,      ;
    m.wwtm06,      ;    
    m.wwtp01,      ;
    m.wwtp02,      ;
    m.wwtp03,      ;
    m.wwtp04,      ;
    m.wwtp05,      ;
    m.wwtp06

    m.wwfcognome   = fiduciario.fcognome
    m.wwfnome      = fiduciario.fnome
    m.wwcodice     = fiduciario.codice
    m.wwragsoc     = fiduciario.ragsoc  
    m.wwprofessio  = fiduciario.professio  
    m.wwspecializ  = fiduciario.specializ  
    m.wwnialbo     = fiduciario.nialbo  
    m.wwcodfisc    = fiduciario.codfisc
    m.wwpiva       = fiduciario.piva     
    m.wwdug        = fiduciario.dug  
    m.wwlocalita   = fiduciario.localita  
    m.wwnc         = fiduciario.nc  
    m.wwcap        = fiduciario.cap  
    m.wwcomune     = fiduciario.comune  
    m.wwprov       = fiduciario.prov  
    m.wwnaz_dsc    = fiduciario.naz_dsc
    m.wwtelefono   = fiduciario.telefono  
    m.wwcellulare  = fiduciario.cellulare  
    m.wwtelefax    = fiduciario.telefax  
    m.wwemail      = fiduciario.email  
    m.wwrtitolo    = fiduciario.rtitolo  
    m.wwrcognome   = fiduciario.rcognome  
    m.wwrnome      = fiduciario.rnome  
    m.wwfunzione   = fiduciario.funzione  
    m.wwbanca      = fiduciario.banca  
    m.wwcab        = fiduciario.cab  
    m.wwabi        = fiduciario.abi  
    m.wwcc         = fiduciario.cc  
    m.wwpm01       = fiduciario.pm01  
    m.wwpm02       = fiduciario.pm02  
    m.wwpm03       = fiduciario.pm03  
    m.wwpm04       = fiduciario.pm04  
    m.wwpm05       = fiduciario.pm05  
    m.wwpm06       = fiduciario.pm06  
    m.wwpp01       = fiduciario.pp01  
    m.wwpp02       = fiduciario.pp02  
    m.wwpp03       = fiduciario.pp03  
    m.wwpp04       = fiduciario.pp04  
    m.wwpp05       = fiduciario.pp05  
    m.wwpp06       = fiduciario.pp06  
    m.wwtm01       = fiduciario.tm01  
    m.wwtm02       = fiduciario.tm02  
    m.wwtm03       = fiduciario.tm03  
    m.wwtm04       = fiduciario.tm04  
    m.wwtm05       = fiduciario.tm05  
    m.wwtm06       = fiduciario.tm06  
    m.wwtp01       = fiduciario.tp01  
    m.wwtp02       = fiduciario.tp02  
    m.wwtp03       = fiduciario.tp03  
    m.wwtp04       = fiduciario.tp04  
    m.wwtp05       = fiduciario.tp05  
    m.wwtp06       = fiduciario.tp06  



*-- area intelligence
    create table ("c:\@\punctum\siis\cache\FBuffer.dbf") free ;
       ( tipo       c(040), ;
         ragsoc     c(080), ;
         siglaprov  c(002), ;
         cap        c(006), ;
         localita   c(080), ;
         dsc        c(100)   )
         
         
   select lcompagnie
   set filter to lcompagnie.fdcr_rif = fiduciario.fdcr_cdc
   go top
   scan 
      
      select FBuffer
      append blank
      replace FBuffer.tipo    with  "Compagnia"
      replace FBuffer.ragsoc  with  lcompagnie.ragsoc
      replace FBuffer.dsc     with  lcompagnie.ragsoc

      select lcompagnie
   endscan      
     

  select zone
  set filter to zone.fdcr_rif = fiduciario.fdcr_cdc
  go top
  scan
  
      select FBuffer
      append blank
      replace FBuffer.tipo       with  "Zone"
      replace FBuffer.siglaprov  with  zone.siglaprov
      replace FBuffer.cap        with  zone.cap
      replace FBuffer.localita   with  zone.localita
      replace FBuffer.dsc        with  alltrim(zone.siglaprov)+" - "+alltrim(zone.cap)+" "+alltrim(zone.localita)
     
     select zone
  endscan


  select FBuffer
  go top
  m.xReport = "r02_cardfiduciario.frx"
  
  REPORT FORM (m.xReport) ;
         ALL              ;
         NOCONSOLE        ;
         PREVIEW



endproc


*--------------------------------------------------------------------------------------------------------------------------


procedure GetFastListOmonimi( m.xiCognome as String, m.xiNome as String)
 
 local m.zxSnst_cdc
 local m.zxRow
 local m.zxEntity
 
 public m.OmoSelected as Integer
 m.OmoSelected = 1
  
 m.zxSnst_cdc = 0
 m.zxRow      = 0  
 m.xiCognome = upper(alltrim(m.xiCognome))
 m.xiNome    = upper(alltrim(m.xiNome))
 
 
 *-- Prepare Cache
     if used ("omo")
        select omo
        use
     endif
     
     public m.LQRS
     m.LQRS = m.GS_LRP+"cache\"+alltrim(m.gs_ragsoc)+"\"  
    
     =MKDIR(JUSTPATH(ALLTRIM(m.LQRS)))

     create table (alltrim(m.LQRS)+"omo.dbf") free ;
       ( snst_cdc    N(010), ;
         cmpg_rif    N(010), ;
         cmpg_ania   C(010), ;
         compagnia   C(100), ;         
         agenzia     C(080), ;
         agnz_cod    C(020), ;
         anno        N(004), ;
         numero      C(040), ;
         ccodice     C(010), ;
         sin_data    D,      ;
         ocognome    C(040), ;
         onome       C(030), ;
         odsc        C(080), ;
         ocdc        N(010), ;
         tipo        C(005), ;
         polizza     C(040), ;         
         assictarga  C(020), ;
         ;
         giur_forma  C(030), ;
         nasc_data   D,      ;
         nasc_com    C(040), ;
         nasc_prov   c(002), ;
         codfisc     C(020), ;
         piva        C(020), ;
         telefono    C(040), ;
         cellulare   C(040), ;
         telefax     C(040), ;
         email       C(100), ;
         pat_num     C(030), ;
         pat_cat     c(010), ;
         pat_ril_da  C(060), ;
         pat_ril_il  D,      ;
         pat_val_al  D,      ;
         ;
         odug        C(020), ;
         olocalita   C(080), ;
         onc         C(010), ;
         ocap        C(006), ;
         ocomune     C(060), ;
         oprov       C(002)  )

 *-- Search Key
     local M.SKey as String     
     m.SKey=UPPER(ALLTRIM(m.xiCognome))
 
 *-- Get Assicurato Omonimo 
     set exact on
     select asscto
     set order to acognome ascending     
     if  seek(m.SKey,"asscto","acognome") 
         
         if  ( recno("asscto") > 0 )
	 	     select omo
		     append blank
	         replace omo.ocognome    with asscto.acognome
	         replace omo.onome       with asscto.anome
	         replace omo.odsc        with "Assicurato"
	         replace omo.tipo        with "A"
	         replace omo.ocdc        with asscto.assc_cdc
	         replace omo.snst_cdc    with asscto.snst_rif
	         replace omo.odug        with asscto.dug
	         replace omo.olocalita   with asscto.localita
	         replace omo.onc         with asscto.nc
	         replace omo.ocap        with asscto.cap
	         replace omo.ocomune     with asscto.comune
	         replace omo.oprov       with asscto.prov
	         replace omo.giur_forma  with asscto.giur_forma
	         replace omo.nasc_data   with asscto.nasc_data
	         replace omo.nasc_com    with asscto.nasc_com
	         replace omo.nasc_prov   with asscto.nasc_prov
	         replace omo.codfisc     with asscto.codfisc
	         replace omo.piva        with asscto.piva
	         replace omo.telefono    with asscto.telefono
	         replace omo.cellulare   with asscto.cellulare
	         replace omo.telefax     with asscto.telefax
	         replace omo.email       with asscto.email
	         replace omo.pat_num     with asscto.pat_num
	         replace omo.pat_cat     with asscto.pat_cat
	         replace omo.pat_ril_da  with asscto.pat_ril_da
	         replace omo.pat_ril_il  with asscto.pat_ril_il 
	         replace omo.pat_val_al  with asscto.pat_val_al
         endif
         
         select asscto
         skip 1
         do while ( upper(alltrim(asscto.acognome)) == m.SKey ) and ( not eof("asscto") ) 
            
             if  ( recno("asscto") > 0 )
		 	     select omo
			     append blank
		         replace omo.ocognome    with asscto.acognome
		         replace omo.onome       with asscto.anome
		         replace omo.odsc        with "Assicurato"
		         replace omo.tipo        with "A"
		         replace omo.ocdc        with asscto.assc_cdc
		         replace omo.snst_cdc    with asscto.snst_rif
		         replace omo.odug        with asscto.dug
		         replace omo.olocalita   with asscto.localita
		         replace omo.onc         with asscto.nc
		         replace omo.ocap        with asscto.cap
		         replace omo.ocomune     with asscto.comune
		         replace omo.oprov       with asscto.prov
		         replace omo.giur_forma  with asscto.giur_forma
		         replace omo.nasc_data   with asscto.nasc_data
		         replace omo.nasc_com    with asscto.nasc_com
		         replace omo.nasc_prov   with asscto.nasc_prov
		         replace omo.codfisc     with asscto.codfisc
		         replace omo.piva        with asscto.piva
		         replace omo.telefono    with asscto.telefono
		         replace omo.cellulare   with asscto.cellulare
		         replace omo.telefax     with asscto.telefax
		         replace omo.email       with asscto.email
		         replace omo.pat_num     with asscto.pat_num
		         replace omo.pat_cat     with asscto.pat_cat
		         replace omo.pat_ril_da  with asscto.pat_ril_da
		         replace omo.pat_ril_il  with asscto.pat_ril_il 
		         replace omo.pat_val_al  with asscto.pat_val_al
	         endif
	         
	         select asscto
	         skip 1
         enddo
         
     endif         
                 
 
 *-- Get Soggetto Collegato Assicurato Omonimo
     set exact on
     select asogcoll
     set order to cognome ascending
     if  seek(m.SKey,"asogcoll","cognome")  
         if  ( recno("asogcoll") > 0 )    
		     select omo
		     append blank
	         replace omo.ocognome    with asogcoll.cognome
	         replace omo.onome       with asogcoll.nome
	         replace omo.odsc        with "Soggetto Collegato Assicurato: "+alltrim(asogcoll.tso_dsc)
	         replace omo.tipo        with "SCA"
	         replace omo.ocdc        with asogcoll.sgcl_cdc
	         replace omo.snst_cdc    with asogcoll.snst_rif
	         replace omo.odug        with asogcoll.dug
	         replace omo.olocalita   with asogcoll.localita
	         replace omo.onc         with asogcoll.nc
	         replace omo.ocap        with asogcoll.cap
	         replace omo.ocomune     with asogcoll.comune
	         replace omo.oprov       with asogcoll.prov
	         replace omo.giur_forma  with asogcoll.giur_forma
	         replace omo.nasc_data   with asogcoll.nasc_data
	         replace omo.nasc_com    with asogcoll.nasc_com
	         replace omo.nasc_prov   with asogcoll.nasc_prov
	         replace omo.codfisc     with asogcoll.cod_fisc 
	         replace omo.piva        with asogcoll.piva
	         replace omo.telefono    with asogcoll.telefono
	         replace omo.cellulare   with asogcoll.cellulare
	         replace omo.telefax     with asogcoll.telefax
	         replace omo.email       with asogcoll.email
	         replace omo.pat_num     with asogcoll.pat_num
	         replace omo.pat_cat     with asogcoll.pat_cat
	         replace omo.pat_ril_da  with asogcoll.pat_ril_da
	         replace omo.pat_ril_il  with asogcoll.pat_ril_il 
	         replace omo.pat_val_al  with asogcoll.pat_val_al
         endif
         
         select asogcoll
         skip 1
         do while ( upper(alltrim(asogcoll.cognome)) == m.SKey ) and ( not eof("asogcoll") ) 
            
            if  ( recno("asogcoll") > 0 ) 
			    select omo
			    append blank
		        replace omo.ocognome    with asogcoll.cognome
		        replace omo.onome       with asogcoll.nome
		        replace omo.odsc        with "Soggetto Collegato Assicurato: "+alltrim(asogcoll.tso_dsc)
		        replace omo.tipo        with "SCA"
		        replace omo.ocdc        with asogcoll.sgcl_cdc
		        replace omo.snst_cdc    with asogcoll.snst_rif
		        replace omo.odug        with asogcoll.dug
		        replace omo.olocalita   with asogcoll.localita
		        replace omo.onc         with asogcoll.nc
		        replace omo.ocap        with asogcoll.cap
		        replace omo.ocomune     with asogcoll.comune
		        replace omo.oprov       with asogcoll.prov
		        replace omo.giur_forma  with asogcoll.giur_forma
		        replace omo.nasc_data   with asogcoll.nasc_data
		        replace omo.nasc_com    with asogcoll.nasc_com
		        replace omo.nasc_prov   with asogcoll.nasc_prov
		        replace omo.codfisc     with asogcoll.cod_fisc 
		        replace omo.piva        with asogcoll.piva
		        replace omo.telefono    with asogcoll.telefono
		        replace omo.cellulare   with asogcoll.cellulare
		        replace omo.telefax     with asogcoll.telefax
		        replace omo.email       with asogcoll.email
		        replace omo.pat_num     with asogcoll.pat_num
		        replace omo.pat_cat     with asogcoll.pat_cat
		        replace omo.pat_ril_da  with asogcoll.pat_ril_da
		        replace omo.pat_ril_il  with asogcoll.pat_ril_il 
		        replace omo.pat_val_al  with asogcoll.pat_val_al
            endif
            
	        select asogcoll
	        skip 1
         enddo
         
     endif

 
 *-- Get Controparte
     select vsparte
     set order to ccognome ascending
     set exact on
     if  seek(m.SKey,"vsparte","ccognome") 
         
         if  ( recno("vsparte") > 0 )  
		     select omo
		     append blank
	         replace omo.ocognome    with vsparte.ccognome
	         replace omo.onome       with vsparte.cnome
	         replace omo.odsc        with "Controparte"
	         replace omo.tipo        with "C"
	         replace omo.ocdc        with vsparte.cntr_cdc
	         replace omo.snst_cdc    with vsparte.snst_rif
	         replace omo.odug        with vsparte.dug
	         replace omo.olocalita   with vsparte.localita
	         replace omo.onc         with vsparte.nc
	         replace omo.ocap        with vsparte.cap
	         replace omo.ocomune     with vsparte.comune
	         replace omo.oprov       with vsparte.prov
	         replace omo.giur_forma  with vsparte.giur_forma
	         replace omo.nasc_data   with vsparte.nasc_data
	         replace omo.nasc_com    with vsparte.nasc_com
	         replace omo.nasc_prov   with vsparte.nasc_prov
	         replace omo.codfisc     with vsparte.codfisc
	         replace omo.piva        with vsparte.piva
	         replace omo.telefono    with vsparte.telefono
	         replace omo.cellulare   with vsparte.cellulare
	         replace omo.telefax     with vsparte.telefax
	         replace omo.email       with vsparte.email
	         replace omo.pat_num     with vsparte.pat_num
	         replace omo.pat_cat     with vsparte.pat_cat
	         replace omo.pat_ril_da  with vsparte.pat_ril_da
	         replace omo.pat_ril_il  with vsparte.pat_ril_il 
	         replace omo.pat_val_al  with vsparte.pat_val_al
         endif
         
         select vsparte
         skip 1 in vsparte
         do  while ( upper(alltrim(vsparte.ccognome)) == m.SKey ) and ( not eof("vsparte") ) 
              
             if  ( recno("vsparte") > 0 )   
			     select omo
			     append blank
		         replace omo.ocognome    with vsparte.ccognome
		         replace omo.onome       with vsparte.cnome
		         replace omo.odsc        with "Controparte"
		         replace omo.tipo        with "C"
		         replace omo.ocdc        with vsparte.cntr_cdc
		         replace omo.snst_cdc    with vsparte.snst_rif
		         replace omo.odug        with vsparte.dug
		         replace omo.olocalita   with vsparte.localita
		         replace omo.onc         with vsparte.nc
		         replace omo.ocap        with vsparte.cap
		         replace omo.ocomune     with vsparte.comune
		         replace omo.oprov       with vsparte.prov
		         replace omo.giur_forma  with vsparte.giur_forma
		         replace omo.nasc_data   with vsparte.nasc_data
		         replace omo.nasc_com    with vsparte.nasc_com
		         replace omo.nasc_prov   with vsparte.nasc_prov
		         replace omo.codfisc     with vsparte.codfisc
		         replace omo.piva        with vsparte.piva
		         replace omo.telefono    with vsparte.telefono
		         replace omo.cellulare   with vsparte.cellulare
		         replace omo.telefax     with vsparte.telefax
		         replace omo.email       with vsparte.email
		         replace omo.pat_num     with vsparte.pat_num
		         replace omo.pat_cat     with vsparte.pat_cat
		         replace omo.pat_ril_da  with vsparte.pat_ril_da
		         replace omo.pat_ril_il  with vsparte.pat_ril_il 
		         replace omo.pat_val_al  with vsparte.pat_val_al
            endif
             
	        select vsparte
	        skip 1
         enddo
         
     endif
             

 *-- Get Soggetto Collegato Controparte 
     select csogcoll
     set exact on
     set order to cognome ascending
     if  seek(m.SKey,"csogcoll","cognome") 
         
         if  ( recno("csogcoll") > 0 )  
		     select omo
		     append blank
	         replace omo.ocognome    with csogcoll.cognome
	         replace omo.onome       with csogcoll.nome
	         replace omo.odsc        with "Soggetto Collegato Controparte: "+alltrim(csogcoll.tso_dsc)
	         replace omo.tipo        with "SCC"
	         replace omo.ocdc        with csogcoll.sgcl_cdc
	         replace omo.snst_cdc    with csogcoll.snst_rif
	         replace omo.odug        with csogcoll.dug
	         replace omo.olocalita   with csogcoll.localita
	         replace omo.onc         with csogcoll.nc
	         replace omo.ocap        with csogcoll.cap
	         replace omo.ocomune     with csogcoll.comune
	         replace omo.oprov       with csogcoll.prov

	         replace omo.giur_forma  with csogcoll.giur_forma
	         replace omo.nasc_data   with csogcoll.nasc_data
	         replace omo.nasc_com    with csogcoll.nasc_com
	         replace omo.nasc_prov   with csogcoll.nasc_prov
	         replace omo.codfisc     with csogcoll.cod_fisc 
	         replace omo.piva        with csogcoll.piva
	         replace omo.telefono    with csogcoll.telefono
	         replace omo.cellulare   with csogcoll.cellulare
	         replace omo.telefax     with csogcoll.telefax
	         replace omo.email       with csogcoll.email
	         replace omo.pat_num     with csogcoll.pat_num
	         replace omo.pat_cat     with csogcoll.pat_cat
	         replace omo.pat_ril_da  with csogcoll.pat_ril_da
	         replace omo.pat_ril_il  with csogcoll.pat_ril_il 
	         replace omo.pat_val_al  with csogcoll.pat_val_al
         endif
         
         select csogcoll
         skip 1
         do  while ( upper(alltrim(csogcoll.cognome)) == m.SKey ) and ( not eof("csogcoll") )

             if  ( recno("csogcoll") > 0 )  
			     select omo
			     append blank
		         replace omo.ocognome    with csogcoll.cognome
		         replace omo.onome       with csogcoll.nome
		         replace omo.odsc        with "Soggetto Collegato Controparte: "+alltrim(csogcoll.tso_dsc)
		         replace omo.tipo        with "SCC"
		         replace omo.ocdc        with csogcoll.sgcl_cdc
		         replace omo.snst_cdc    with csogcoll.snst_rif
		         replace omo.odug        with csogcoll.dug
		         replace omo.olocalita   with csogcoll.localita
		         replace omo.onc         with csogcoll.nc
		         replace omo.ocap        with csogcoll.cap
		         replace omo.ocomune     with csogcoll.comune
		         replace omo.oprov       with csogcoll.prov

		         replace omo.giur_forma  with csogcoll.giur_forma
		         replace omo.nasc_data   with csogcoll.nasc_data
		         replace omo.nasc_com    with csogcoll.nasc_com
		         replace omo.nasc_prov   with csogcoll.nasc_prov
		         replace omo.codfisc     with csogcoll.cod_fisc 
		         replace omo.piva        with csogcoll.piva
		         replace omo.telefono    with csogcoll.telefono
		         replace omo.cellulare   with csogcoll.cellulare
		         replace omo.telefax     with csogcoll.telefax
		         replace omo.email       with csogcoll.email
		         replace omo.pat_num     with csogcoll.pat_num
		         replace omo.pat_cat     with csogcoll.pat_cat
		         replace omo.pat_ril_da  with csogcoll.pat_ril_da
		         replace omo.pat_ril_il  with csogcoll.pat_ril_il 
		         replace omo.pat_val_al  with csogcoll.pat_val_al
            endif
            
	        select csogcoll
	        skip 1
         enddo

         
     endif
 
endproc
*--------------------------------------------------------------------------------------------------------------------------










