* PHYSICAL INTEGRITY SUB-SYSTEM

*------------------------------------------------------------------------------
FUNCTION PH_SetMirroring (M.iSet, M.iWhere)

* SECTION SERVICE
LOCAL M.IReturn 
M.IReturn = .F.

* AREA INTELLIGENCE

IF NOT EMPTY(ALLTRIM(M.iWhere))
   
   DO FORM c:\@contatto\InfoMsg.scx WITH "Duplica su "+ALLTRIM(M.iWhere)+" in corso ..."
   
   IF NOT DRIVETYPE(JUSTDRIVE(M.iWhere)) = 0 && Il Drive  presente sul Sistema di Elaborazione
      LOCAL M.aErrorHandler, M.mError, M.SetNameDst
      M.aErrorHandler = ON("ERROR")
      M.mError        = .F.
      M.SetNameDst    = ALLTRIM(M.iWhere)+ALLTRIM(M.iSet)
      
      ON ERROR M.mError = .T.
      
      * Folder Created with successful or Folder alredy exists       
      IF MKDIR(JUSTPATH(ALLTRIM(M.iWhere))) = 0 ;
      OR MKDIR(JUSTPATH(ALLTRIM(M.iWhere))) = 6 ;
      OR MKDIR(JUSTPATH(ALLTRIM(M.iWhere))) = 17

         IF USED(SUBSTR(ALLTRIM(M.iSet),1,AT(".",ALLTRIM(M.iSet))-1 ))
                     
            SET SAFETY OFF
            SELECT 100
            SELECT ALL * FROM (M.iSet) INTO TABLE (M.SetNameDst)
            
            USE
            IF NOT M.mError
               M.IReturn = .T.
            ELSE
               M.IReturn = .F.
            ENDIF
         ELSE
            M.IReturn = .F.
         ENDIF
         
      ELSE
         M.IReturn = .F.   
      ENDIF
      
      ON ERROR &aErrorHandler 
   ELSE
     M.IReturn = .F.   
   ENDIF
   
   RELEASE WINDOW InfoMsg
   
ELSE
   M.IReturn = .F.      
ENDIF

RETURN M.IReturn
ENDFUNC
*------------------------------------------------------------------------------
FUNCTION PH_InfoBaseMirroring (M.iInfoBase, M.iWhere)

* SECTION SERVICE
LOCAL M.IReturn 
M.IReturn = .F.

* AREA INTELLIGENCE
  M.iInfoBase = ALLTRIM(M.iInfoBase)
  
  IF NOT EMPTY(M.iWhere)
     SET SAFETY OFF
     SET DEFAULT TO (M.iInfoBase)
     
     PUBLIC ARRAY SetList[01]
         
     =ADIR(SetList,"*.DBF")
     
     *LOCAL M.NumSet
     PUBLIC  M.NumSet
     M.NumSet= ALEN(SetList,1)
     
     FOR J=1 TO M.NumSet STEP 1
         DO PH_SetMirroring WITH SetList[M.J,1], M.iWhere
     ENDFOR
          
  ENDIF


RETURN M.IReturn
ENDFUNC

*------------------------------------------------------------------------------
