* SECURITY AND ACCESS CONTROL (SAC) ( PRIVACY AND RESERVE ) SUBSYSTEM


*--------------------------------------------------------------------------------------------
FUNCTION SAC_CHECK ()
***
* PURPOSE > Check The logica Integrity Of USERS Meta-Set
***

* SECTION SERVICE
  
* AREA INTELLIGENCE
IF NOT USED("USERS")
   RETURN .F.
ELSE
   SELECT USERS
   LOCATE FOR UPPER(ALLTRIM(USERS.UNAME))="AMMINISTRATORE"
   IF NOT FOUND("USERS")
   
      IF FLOCK("USERS")
         LOCAL M.kData, M.kTime
         M.kData = DATE()
         M.kTIME = TIME()
         INSERT INTO USERS (UNAME, UPASS, UDATA, URIGTHS) ;                         
          VALUES ("AMMINISTRATORE", M.kData, M.kTime,SAC_CRYPTOR ("AMMINISTRATORE", M.kData, M.kTempo),REPLICATE("1",10))                         
         UNLOCK IN USERS
         RETURN .T.
      ELSE
         RETURN .F.
      ENDIF
      
   ELSE
      RETURN .T.            
   ENDIF
   
   
ENDIF
   

ENDFUNC
*--------------------------------------------------------------------------------------------
FUNCTION SAC_CRYPTOR (M.xiChiave, M.xiData, M.xiTempo)
***
* PURPOSE > Crittografatore (ListSymbols,ListNumbers) -- > [Number]
*           without using internal representation.
***

* SECTION SERVICE
DIMENSION PassCode[10]
STORE 0 TO PassCode
  
DIMENSION JO[10]
STORE 0 TO JO
  
* AREA INTELLIGENCE

  * CONSIDERAZIONE SOLO PRIMI 10 CARATTERI
  M.xiChiave=ALLTRIM(M.xiChiave)
  IF LEN(M.xiChiave) > 10
     M.xiChiave=SUBSTR(M.xiChiave,1,10)
  ELSE
     M.xiChiave=M.xiChiave+SPACE(10-LEN(M.xiChiave))
  ENDIF
  PassCode[01]=ASC(SUBSTR(M.xiChiave,01,1))
  PassCode[02]=ASC(SUBSTR(M.xiChiave,02,1))
  PassCode[03]=ASC(SUBSTR(M.xiChiave,03,1))
  PassCode[04]=ASC(SUBSTR(M.xiChiave,04,1))
  PassCode[05]=ASC(SUBSTR(M.xiChiave,05,1))
  PassCode[06]=ASC(SUBSTR(M.xiChiave,06,1))
  PassCode[07]=ASC(SUBSTR(M.xiChiave,07,1))
  PassCode[08]=ASC(SUBSTR(M.xiChiave,08,1))
  PassCode[09]=ASC(SUBSTR(M.xiChiave,09,1))
  PassCode[10]=ASC(SUBSTR(M.xiChiave,10,1))

   
  * INIZILIAZZA JOLLY OFFSET
  
  JO[01]=DAY(M.xiData)+(Passcode[02]+PassCode[07])
  JO[02]=MONTH(M.xiData)*PassCode[01]
  JO[03]=VAL(SUBSTR(M.xiTempo,1,2))*(PassCode[10]+PassCode[06])
  JO[04]=VAL(SUBSTR(M.xiTempo,4,2))
  JO[05]=VAL(SUBSTR(M.xiTempo,7,2))
  JO[06]=ABS(JO[01]-JO[02])+PassCode[01]
  JO[07]=ABS(JO[03]-JO[04])+PassCode[01]+PassCode[02]+PassCode[03]
  JO[08]=ABS(JO[04]-JO[05])+PassCode[04]+PassCode[05]+PassCode[06]
  JO[09]=ABS(JO[01]-JO[03])+PassCode[07]+PassCode[08]+PassCode[09]
  JO[10]=ABS(JO[02]-JO[05])+PassCode[10]

  * ENCRIPTA PAROLA CHIAVE
  PRIVATE M.SecretCode, M.J
  M.SecretCode=0
  FOR J=1 To 10 STEP 1
      M.SecretCode=M.SecretCode+JO[J]
  ENDFOR
*  
RETURN ALLTRIM(STR(M.SecretCode))

ENDFUNC
*--------------------------------------------------------------------------------------------
procedure SetPermission (m.xiObject as Object, m.xiRights as String)


*-- area intelligence
    
    xiObject.NewEntity.visible = .f.
    
    



endproc
*--------------------------------------------------------------------------------------------

