lparameters m.xi_pbls_rif
 
* M.xiVisionType   : PREVIEW or PRINT
* Rest by Print Communication Area

*-- SECTION SERVICE
	local m.sPbls_Tipo as String
	m.sPbls_Tipo = ""
*-- AREA INTELLIGENCE
 
   *-- Set Up cache folder
	   public m.PathFolderCache as String
	   m.PathFolderCache = m.GS_LRP+"cache\"+alltrim(m.gs_pbls_des)+"\" 
	   =MKDIR(JUSTPATH(ALLTRIM(m.PathFolderCache)))
	    
   *-- Information Retrival
       do form InfoMsg.scx with "Generazione Graduatoria in corso ..."
       if used("XLista") then
          select XLista
          use
       endif
       if used("XPosto") then
          select XPosto
          use
       endif
       if used("XPosto00") then
          select XPosto00
          use
       endif       
       if used("XPubl") then
          select XPubl
          use
       endif
       if used("XCand") then
          select XCand
          use
       endif
       if used("XGrad") then
          select XGrad
          use
       endif
       if used("XStorico") then
          select XStorico
          use
       endif

       m.pca_gavv5aa   = 0
       select epublist
       locate for epublist.pbls_ide = m.xi_pbls_rif

       if found("epublist") then
          m.pca_gavv5aa  = epublist.gavv5aa
          m.pca_gbggmae  = epublist.gbggmae
          m.sPbls_Tipo   = epublist.pbls_tipo
       else
          return   
       endif

       *-- Base Entity
	       select tdomanda.matricola,       ;
	              tdomanda.cognome,         ;
	              tdomanda.nome,            ;
	              tdomanda.sesso,           ;
                  ;
	              tdomanda.sa_b,            ;
	              tdomanda.sa_disagio,      ;
	              tdomanda.pacp5a,          ;
	              tdomanda.avvuff,          ;
	              tdomanda.sbprm,           ;
	              tdomanda.ac_flag,         ;
	              tdomanda.msr,             ;
	              ;
	              tdomanda.dnascita,        ;
	              tdomanda.qualifica,       ;
	              tdomanda.ppdesc,          ;
	              tdomanda.ppcode,          ;
	              space(080) as td_pfdesc,  ;
	              space(080) as sede_att,   ;
	              tdomanda.pm_dsz1,         ;		
	              tdomanda.pm_dsz2,         ;		
	              tdomanda.ntp_rif,         ;		                            
	              tdomanda.sedea_dal,       ;
	              tdomanda.sedea_dsc,       ;
	              tdomanda.em,              ;
	              tdomanda.protocollo,      ;
	              tdomanda.enote,           ;
	              tdomanda.wnote,           ;
	              space(200) as td_lingue,  ;
	              space(200) as td_curr,    ;
	              space(200) as td_corsi,   ;
	              space(254) as pas,        ;
	              0000       as ngrad,      ;
	              00         as amn,        ; && Appartenenza/Maturato/Negativo
	              tdomanda.lingua01,        ;
	              tdomanda.lingua02,        ;
	              tdomanda.lingua03,        ;
	              tdomanda.lingua04,        ;
	              tdomanda.lingua05,        ;
	              tdomanda.livello01,       ;
	              tdomanda.livello02,       ;
	              tdomanda.livello03,       ;
	              tdomanda.livello04,       ;
	              tdomanda.livello05,       ;
	              tdomanda.corso01,         ;
	              tdomanda.corso02,         ;
	              tdomanda.corso03,         ;
	              tdomanda.corso04,         ;
	              tdomanda.corso05,         ;
	              tdomanda.corso06,         ;
	              tdomanda.corso07,         ;
	              tdomanda.corso08,         ;
	              tdomanda.corso09,         ;
	              tdomanda.corso10,         ;
	              tdomanda.corso11,         ;
	              tdomanda.corso12,         ;
                  tdomanda.curr01,          ;	              
                  tdomanda.curr02,          ;	              
                  tdomanda.curr03,          ;	              
                  tdomanda.curr04,          ;	              
                  tdomanda.curr05,          ;	              
                  tdomanda.curr06,          ;	              
                  tdomanda.curr07,          ;	              
                  tdomanda.curr08,          ;	              
                  tdomanda.curr09,          ;	              
                  tdomanda.curr10,          ;	              
                  tdomanda.curr11,          ;	              
                  tdomanda.curr12,          ;	              
                  tdomanda.curr13,          ;	              
                  tdomanda.curr14,          ;	
                  tdomanda.curr15,          ;	
                  tdomanda.curr16,          ;	              
                  tdomanda.nslng01,         ;	              
                  tdomanda.nslng02,         ;	              
                  tdomanda.nslng03,         ;	              
                  tdomanda.nslng04,         ;	              
                  tdomanda.nslng05,         ;	                                                                                      
                  tdomanda.bollettino,      ;	              
                  tdomanda.druolimae,       ;	              
                  tdomanda.decarriera,      ;	              
                  tdomanda.deprofilo,       ;	 
                  tdomanda.dapregctr,       ;	
                  tdomanda.dapregcom,       ;	
                  tdomanda.dammprov,        ;	
                  tdomanda.dcessmae,        ;	
                  tdomanda.dataestero,      ;	  
                  tdomanda.tggmae,          ;	
                  tdomanda.gg15com,         ;
                  00000      as gpm,        ;	                          
                  tdomanda.chb,             ;	              
                  tdomanda.cha,             ;	              
                  tdomanda.cric,            ;	              
                  tdomanda.turn,            ;	              
                  tdomanda.eu5a,            ;	
                  tdomanda.psb,             ;	              
                  tdomanda.gric             ;	                                                         
	         from tdomanda ;
	        where ( not deleted("tdomanda") )         ;
	          and tdomanda.pbls_rif =  m.xi_pbls_rif ;
	          and tdomanda.gric     = 1               ;
	        into table (m.PathFolderCache+"XLista.dbf") 

           
	       select tdposto.protocollo,       ;
	              tdposto.pref,             ;        
	              tdposto.nsedia,           ;
	              tdposto.pjob,             ;
	              tdposto.prel,             ;
	              tdposto.plingua,          ;
	              tdposto.sricev            ;
	         from tdposto ;
	        where ( not deleted("tdposto") )         ;
	          and tdposto.pbls_rif =  m.xi_pbls_rif  ;
	          and tdposto.escludi  = 0               ;
	        into table (m.PathFolderCache+"XPosto00.dbf") 

	       select trlist.nsedia,           ;
	              trlist.ntp_rif,          ;
	              trlist.paese,            ;
	              trlist.rango,            ;
	              space(10) as shortrango, ;
	              trlist.sede,             ;
	              trlist.disagio,          ;
	              trlist.bellica,          ;
	              trlist.diffcop,          ;
	              trlist.romana,           ;
	              trlist.motivodes,        ;
	              trlist.qualifica,        ;
	              trlist.ppcode,           ;
	              trlist.pfdesc,           ;
	              trlist.lingua01,         ;
	              trlist.lingua02,         ;
	              trlist.lingua03,         ;
	              trlist.lingua04,         ;
	              trlist.lingua05,         ;
	              trlist.livello01,        ;
	              trlist.livello02,        ;
	              trlist.livello03,        ;
	              trlist.livello04,        ;
	              trlist.livello05,        ;	              
	              trlist.log01,            ;
	              trlist.log02,            ;
	              trlist.log03,            ;
	              trlist.log04,            ;	              
	              trlist.notades,          ;
	              trlist.annota            ;
	         from trlist  ;
	        where ( not deleted("trlist") )         ;
	          and trlist.pbls_rif =  m.xi_pbls_rif  ;
	        into table (m.PathFolderCache+"XPubl.dbf") 

	       select * ;
	        from XPosto00;
	       where XPosto00.protocollo in ;
	             ( select distinct XLista.protocollo from XLista ) ;
	       into table (m.PathFolderCache+"XPosto.dbf") 


	       select oestorico.matricola,     ;
	              oestorico.dataasspos,    ;        
	              oestorico.datacesspo,    ;        
	              oestorico.annota         ;
	         from oestorico                ;
	        where ( not deleted("oestorico") )   ;
	          and oestorico.matricola in         ;
	              ( select distinct XLista.matricola from XLista ) ;
	        into table (m.PathFolderCache+"XStorico.dbf") 

       
       *-- Assembled Entity
	       select xposto.protocollo,      ;
	              xposto.pref,            ;        
	              xposto.nsedia,          ;
	              xposto.pjob,            ;
	              xposto.prel,            ;
	              xposto.plingua,         ;
	              xposto.sricev,          ;       
	              ;
	              xlista.matricola,       ;
	              xlista.cognome,         ;
	              xlista.nome,            ;
	              xlista.sesso,           ;
	              ;
	              xlista.sa_b,            ;
	              xlista.sa_disagio,      ;
	              xlista.pacp5a,          ;
	              xlista.avvuff,          ;
	              xlista.sbprm,           ;
	              xlista.ac_flag,         ;
	              xlista.msr,             ;
	              ;
	              xlista.dnascita,        ;
	              xlista.qualifica,       ;
	              xlista.ppdesc,          ;
	              xlista.ppcode,          ;
	              xlista.td_pfdesc,       ;
	              xlista.sede_att,        ;
	              xlista.pm_dsz1,         ;
	              xlista.pm_dsz2,         ;
	              xlista.ntp_rif,         ;
	              xlista.sedea_dal,       ;
	              xlista.sedea_dsc,       ;
	              xlista.em,              ;
	              xlista.protocollo as p1,;
	              xlista.enote,           ;
	              xlista.wnote,           ;
	              xlista.td_lingue,       ;
	              xlista.td_corsi,        ;
	              xlista.td_curr,         ;
	              xlista.pas,             ;
	              xlista.ngrad,           ;
	              xlista.amn,             ;
	              xlista.lingua01,        ;
	              xlista.lingua02,        ;
	              xlista.lingua03,        ;
	              xlista.lingua04,        ;
	              xlista.lingua05,        ;
	              xlista.livello01,       ;
	              xlista.livello02,       ;
	              xlista.livello03,       ;
	              xlista.livello04,       ;
	              xlista.livello05,       ;
	              xlista.corso01,         ;
	              xlista.corso02,         ;
	              xlista.corso03,         ;
	              xlista.corso04,         ;
	              xlista.corso05,         ;
	              xlista.corso06,         ;
	              xlista.corso07,         ;
	              xlista.corso08,         ;
	              xlista.corso09,         ;
	              xlista.corso10,         ;
	              xlista.corso11,         ;
	              xlista.corso12,         ;
                  xlista.curr01,          ;	              
                  xlista.curr02,          ;	              
                  xlista.curr03,          ;	              
                  xlista.curr04,          ;	              
                  xlista.curr05,          ;	              
                  xlista.curr06,          ;	              
                  xlista.curr07,          ;	              
                  xlista.curr08,          ;	              
                  xlista.curr09,          ;	              
                  xlista.curr10,          ;	              
                  xlista.curr11,          ;	              
                  xlista.curr12,          ;	              
                  xlista.curr13,          ;	              
                  xlista.curr14,          ;	              
                  xlista.curr15,          ;	 
                  xlista.curr16,          ;             
                  xlista.nslng01,         ;	              
                  xlista.nslng02,         ;	              
                  xlista.nslng03,         ;	              
                  xlista.nslng04,         ;	              
                  xlista.nslng05,         ;	                                                                                      
                  xlista.bollettino,      ;	              
                  xlista.druolimae,       ;	              
                  xlista.decarriera,      ;	              
                  xlista.deprofilo,       ;	  
                  xlista.dapregctr,       ;	
                  xlista.dapregcom,       ;	
                  xlista.dammprov,        ;	 
                  xlista.dcessmae,        ;	 
                  xlista.dataestero,      ;	                                       
                  xlista.tggmae,          ;	
                  xlista.gpm,             ;	
                  xlista.gg15com,         ;	                          
                  xlista.chb,             ;	              
                  xlista.cha,             ;	              
                  xlista.cric,            ;	              
                  xlista.turn,            ;	              
                  xlista.eu5a,            ;	 
                  xlista.psb,             ;	              
                  xlista.gric             ;	 
                  ;                                                        
	         from xposto                            ;
	       left outer join xlista                   ;
	       on xposto.protocollo = xlista.protocollo ;
	       into table (m.PathFolderCache+"XCand.dbf") 

           select distinct xcand.matricola ;
             from xcand ;
           into cursor citnd
           m.pca_ITNDomande = reccount("citnd")   

	       select nvl(xcand.protocollo,0)  as protocollo,    ;
	              nvl(xcand.pref,0)        as pref,          ;        
	              nvl(xcand.nsedia,0)      as cnsedia,       ;
	              nvl(xcand.pjob,0)        as pjob,          ;
	              nvl(xcand.prel,"")       as prel,          ;
	              nvl(xcand.plingua,0)     as plingua,       ;
	              00                       as tplingua,      ;  
	              0                        as wow,           ;             	              
	              nvl(xcand.sricev,0)      as sricev,        ;       
	              nvl(xcand.matricola,0)   as matricola,     ;
	              nvl(xcand.cognome,"")    as cognome,       ;
	              nvl(xcand.nome,"")       as nome,          ;
	              nvl(xcand.sesso,"")      as sesso,         ;
	              ;
	              nvl(xcand.sa_b,0)        as sa_b,          ;
	              nvl(xcand.sa_disagio,"") as sa_disagio,    ;
	              nvl(xcand.pacp5a,0)      as pacp5a,        ;
	              nvl(xcand.avvuff,0)      as avvuff,        ;
	              nvl(xcand.sbprm,0)       as sbprm,         ;
	              nvl(xcand.ac_flag,0)     as ac_flag,       ;	              
	              nvl(xcand.msr,0)         as msr,           ;	              
	              ;
	              nvl(xcand.dnascita,{})   as dnascita,      ;
	              nvl(xcand.qualifica,"")  as qualifica,     ;
	              nvl(xcand.sede_att,"")   as sede_att,      ;
	              nvl(xcand.pm_dsz1,"")    as pm_dsz1,       ;
	              nvl(xcand.pm_dsz2,"")    as pm_dsz2,       ;	              
	              nvl(xcand.ppdesc,"")     as ppdesc,        ;
	              nvl(xcand.ppcode,0)      as ppcode,        ;
	              nvl(xcand.td_pfdesc,"")  as td_pfdesc,     ;
	              nvl(xcand.ntp_rif,0)     as ntp_rif,       ;	              
	              nvl(xcand.sedea_dal,{})  as sedea_dal,     ;
	              nvl(xcand.sedea_dsc,"")  as sedea_dsc,     ;
	              nvl(xcand.em,"")         as em,            ;
	              nvl(xcand.p1,0)          as p1,            ;
	              nvl(xcand.enote,"")      as enote,         ;
	              nvl(xcand.wnote,"")      as wnote,         ;
	              nvl(xcand.td_lingue,"")  as td_lingue,     ;
	              nvl(xcand.td_corsi,"")   as td_corsi,      ;
	              nvl(xcand.td_curr,"")    as td_curr,       ;	              
	              nvl(xcand.pas,"")        as pas,           ;	              
	              nvl(xcand.ngrad,0)       as ngrad,         ;	  
	              nvl(xcand.amn,0)         as amn,           ;	              
	              nvl(xcand.lingua01,"")   as lingua01,      ;
	              nvl(xcand.lingua02,"")   as lingua02,      ;
	              nvl(xcand.lingua03,"")   as lingua03,      ;
	              nvl(xcand.lingua04,"")   as lingua04,      ;
	              nvl(xcand.lingua05,"")   as lingua05,      ;
	              nvl(xcand.livello01,"")  as livello01,     ;
	              nvl(xcand.livello02,"")  as livello02,     ;
	              nvl(xcand.livello03,"")  as livello03,     ;
	              nvl(xcand.livello04,"")  as livello04,     ;
	              nvl(xcand.livello05,"")  as livello05,     ;
	              nvl(xcand.corso01,0)     as corso01,       ;
	              nvl(xcand.corso02,0)     as corso02,       ;
	              nvl(xcand.corso03,0)     as corso03,       ;
	              nvl(xcand.corso04,0)     as corso04,       ;
	              nvl(xcand.corso05,0)     as corso05,       ;
	              nvl(xcand.corso06,0)     as corso06,       ;
	              nvl(xcand.corso07,0)     as corso07,       ;
	              nvl(xcand.corso08,0)     as corso08,       ;
	              nvl(xcand.corso09,0)     as corso09,       ;
	              nvl(xcand.corso10,0)     as corso10,       ;
	              nvl(xcand.corso11,0)     as corso11,       ;
	              nvl(xcand.corso12,0)     as corso12,       ;
                  nvl(xcand.curr01,0)      as curr01,        ;	              
                  nvl(xcand.curr02,0)      as curr02,        ;	              
                  nvl(xcand.curr03,0)      as curr03,        ;	              
                  nvl(xcand.curr04,0)      as curr04,        ;	              
                  nvl(xcand.curr05,0)      as curr05,        ;	              
                  nvl(xcand.curr06,0)      as curr06,        ;	               
                  nvl(xcand.curr07,0)      as curr07,        ;	               
                  nvl(xcand.curr08,0)      as curr08,        ;	 	              
                  nvl(xcand.curr09,0)      as curr09,        ;	                
                  nvl(xcand.curr10,0)      as curr10,        ;	 	              
                  nvl(xcand.curr11,0)      as curr11,        ;	 	              
                  nvl(xcand.curr12,0)      as curr12,        ;	              
                  nvl(xcand.curr13,0)      as curr13,        ;	 	              
                  nvl(xcand.curr14,0)      as curr14,        ;	 	              
                  nvl(xcand.curr15,0)      as curr15,        ;	 	
                  nvl(xcand.curr16,0)      as curr16,        ;	               
                  nvl(xcand.nslng01,0)     as nslng01,       ;	              
                  nvl(xcand.nslng02,0)     as nslng02,       ;	              
                  nvl(xcand.nslng03,0)     as nslng03,       ;		              
                  nvl(xcand.nslng04,0)     as nslng04,       ;	              
                  nvl(xcand.nslng05,0)     as nslng05,       ;	                                                                                      
                  nvl(xcand.bollettino,0)  as bollettino,    ;	              
                  nvl(xcand.druolimae,{})  as druolimae,     ;	              
                  nvl(xcand.decarriera,{}) as decarriera,    ;	              
                  nvl(xcand.deprofilo,{})  as deprofilo,     ;	  
                  nvl(xcand.dapregctr,{})  as dapregctr,     ;
                  nvl(xcand.dapregcom,{})  as dapregcom,     ;	                                       
                  nvl(xcand.dammprov,{})   as dammprov,      ;	 
                  nvl(xcand.dcessmae,{})   as dcessmae,      ;
                  nvl(xcand.dataestero,{}) as dataestero,    ; 	                                       
                  nvl(xcand.tggmae,0)      as tggmae,        ;
                  nvl(xcand.gg15com,0)     as gg15com,       ;	   
                  nvl(xcand.gpm,0)         as gpm,           ;	              
                  nvl(xcand.chb,0)         as chb,           ;
                  nvl(xcand.cha,0)         as cha,           ;		                  	              
                  nvl(xcand.cric,0)        as cric,          ;	              
                  nvl(xcand.turn,0)        as turn,          ;	              
                  nvl(xcand.eu5a,0)        as eu5a,          ;	 
                  nvl(xcand.psb,0)         as psb,           ;	              
                  nvl(xcand.gric,0)        as gric,          ;	
                  ;
                  space(100) as pse01,   ;
                  space(100) as pse02,   ;
                  space(100) as pse03,   ;
                  space(100) as pse04,   ;
                  space(100) as pse05,   ;
                  space(100) as pse06,   ;
                  space(100) as pse07,   ;
                  space(100) as pse08,   ;  
                  space(100) as pse09,   ;  
                  space(100) as pse10,   ;  
                  ;
	              xpubl.nsedia   as    nsedia,   ;
	              xpubl.ntp_rif  as tr_ntp_rif,  ;
	              xpubl.paese,                   ;
	              xpubl.rango,                   ;
	              xpubl.shortrango,              ;
	              xpubl.sede,                    ;
	              xpubl.disagio,                 ;
	              xpubl.bellica,                 ;
	              xpubl.diffcop,                 ;
	              xpubl.romana,                  ;
	              xpubl.motivodes,               ;
	              xpubl.qualifica as tr_qual,    ;
	              xpubl.ppcode    as tr_ppcode,  ;			              
	              xpubl.pfdesc,                  ;
	              space(200)      as tr_lingue,  ;
	              xpubl.lingua01  as tr_ling01,  ;
	              xpubl.lingua02  as tr_ling02,  ;
	              xpubl.lingua03  as tr_ling03,  ;
	              xpubl.lingua04  as tr_ling04,  ;
	              xpubl.lingua05  as tr_ling05,  ;
	              xpubl.livello01 as tr_liv01,   ;
	              xpubl.livello02 as tr_liv02,   ;
	              xpubl.livello03 as tr_liv03,   ;
	              xpubl.livello04 as tr_liv04,   ;
	              xpubl.livello05 as tr_liv05,   ;	              
	              xpubl.log01,                   ;
	              xpubl.log02,                   ;
	              xpubl.log03,                   ;
	              xpubl.log04,                   ;
	              xpubl.notades,                 ;
	              xpubl.annota,                  ;
	              0            as  i01,          ;
	              00           as  i02,          ;
	              0            as  i03,          ;
	              0            as  i04,          ;
	              0            as  i05,          ;
	              0            as  i06,          ;
	              0            as  i07,          ;
	              0            as  i08,          ;
	              {}           as  i09,          ;
	              {}           as  i10,          ;
	              0            as  i11,          ;
	              0            as  i12,          ;
	              {}           as  i13,          ;
	              {}           as  i14,          ;
	              00000        as  i15,          ;
	              00000        as  i16,          ;	              
	              space(03)    as  i17,          ;
	              0            as  i18,          ;	              
	              0            as  i19,          ;	              
	              0            as  i20           ;	              
	         from xpubl                             ;
	       left outer join xcand                    ;
	       on xcand.nsedia = xpubl.nsedia           ;
	       into table (m.PathFolderCache+"XGrad.dbf") 
                         
         
    *-- Data Enrichment
        local m.zx_sedeadsc as String
        m.zx_sedeadsc = ""
        select xgrad
        go top
        scan

           *-- A: Corrispondenza della posizione economica e del profilo di appartenenza: Appartenenza/Maturato/Negativo
               do case
                  case upper(alltrim(xgrad.prel))=="APP"
                       select xgrad
                       replace xgrad.amn     with 1 
                       replace xgrad.i01     with 1 
                       
                  case upper(alltrim(xgrad.prel))=="MAT"
                       select xgrad
                       replace xgrad.amn     with 2 
                       replace xgrad.i01     with 2 

                  case upper(alltrim(xgrad.prel))=="NEG"
                       select xgrad
                       replace xgrad.amn     with 3
                       replace xgrad.i01     with 3 

                  otherwise
                       select xgrad
                       replace xgrad.amn     with 4
                       replace xgrad.i01     with 4 
                       
               endcase        
               
           *-- B: Conoscenza della lingua indicata nella lista di pubblicit ovvero della lingua locale della sede
               do case
                  case len(alltrim(xgrad.tr_ling01)) > 0 ;
                   and len(alltrim(xgrad.tr_ling02)) > 0 ;
                   and upper(alltrim(xgrad.log01)) == "E"  
                       do case	
                          case xgrad.plingua = 20
	                           select xgrad
	                           replace xgrad.tplingua with 9
	                           
                          case xgrad.plingua = 10
	                           select xgrad
	                           replace xgrad.tplingua with 1

                          otherwise
	                           select xgrad
	                           replace xgrad.tplingua with 0
	                           
                       endcase                       
                  otherwise
                       do case	
                          case xgrad.plingua = 10
	                           select xgrad
	                           replace xgrad.tplingua with 9
	                           
                          otherwise
	                           select xgrad
	                           replace xgrad.tplingua with 0
	                           
                       endcase
               endcase
               select xgrad
               replace xgrad.i02 with xgrad.tplingua
               
           *-- C: Rispondenza alle caratteristiche indicate nella eventuale nota descrittiva
               select xgrad               
               replace xgrad.i03 with iif(xgrad.pjob>4,xgrad.pjob-5,xgrad.pjob)
                              
           *-- D: Provenienza da Sede Bellica
               select xgrad
               replace xgrad.i04 with xgrad.sa_b
               
           *-- X: Provenienza Disagio Sede    
               if upper(alltrim(xgrad.em))=="M" then
                  select xgrad
                  replace xgrad.i17     with "A"
               else
                  select xgrad
                  replace xgrad.i17     with upper(alltrim(xgrad.sa_disagio))
               endif

           
           *-- E: Provenienza da Sede PD limitatamente alle candidature per le sedi NORMALI
               if upper(alltrim(xgrad.em))=="M" then
                  select xgrad
                  replace xgrad.i05     with 0
               else
                  if  upper(alltrim(xgrad.sa_disagio))=="PD" ;
                  and upper(alltrim(xgrad.disagio))   =="N"     then
		              select xgrad
		              replace xgrad.i05     with 1                  
	             else
		              select xgrad
		              replace xgrad.i05     with 0                                    
	             endif                   
               endif

           *-- F: Provenienza da Sede D limitatamente alle candidature per le sedi NORMALI
               if upper(alltrim(xgrad.em))=="M" then
                  select xgrad
                  replace xgrad.i06     with 0
               else
                  if  upper(alltrim(xgrad.sa_disagio))=="D" ;
                  and upper(alltrim(xgrad.disagio))   =="N"     then
		              select xgrad
		              replace xgrad.i06     with 1                  
	             else
		              select xgrad
		              replace xgrad.i06     with 0                                    
	             endif                   
               endif
               
           *-- G: 1) Avvicendato d'Ufficio da Sede Estera
           *      2) Permanenza presso l'Amministrazione centrale per + di 5 anni
           *      3) Coloro che non hanno mai prestato servizio all'estero dalla data di immissione nei ruoli del MAE
		          select xgrad
		          replace xgrad.i07     with 0
		          if ( xgrad.pacp5a = 1 or xgrad.avvuff= 1 ) then
			          select xgrad
			          replace xgrad.i07     with 1		          
		          endif                  
*!*					  m.NeverAbroad = .t.
*!*					  if seek(xgrad.matricola,"attuali","matricola")   then
*!*						 m.NeverAbroad = .f.
*!*				   	  endif
*!*					  if seek(xgrad.matricola,"assegna","matricola")   then
*!*						 m.NeverAbroad = .f.
*!*					  endif
*!*					  if seek(xgrad.matricola,"precede","matricola")   then
*!*						 m.NeverAbroad = .f.
*!*					  endif
*!*					  if seek(xgrad.matricola,"oestorico","matricola") then
*!*						 m.NeverAbroad = .f.
*!*					  endif
*!*	  				  if m.NeverAbroad then
*!*				         select xgrad
*!*				         replace xgrad.i07     with 1	
*!*				         replace xgrad.i18     with 1	&& Never Abroad	          
*!*					  endif
                  
           *--  H: Permanenza presso l'Amministrazione centrale da meno di 5 anni avendo prestato l'ultimo servizio in sede Bellica
				if upper(alltrim(xgrad.em))=="E" then
				   select xgrad
				   replace xgrad.i08   with 0
				else
				   if (xgrad.sbprm = 1 and xgrad.pacp5a = 0 ) then
				      select xgrad
				      replace xgrad.i08   with 1
				   else
				      select xgrad
				      replace xgrad.i08   with 0   
				   endif   

				endif
           

           *--  I: Anzianit di inquadramento dei ruoli del MAE nel profilo professionale di appartenenza nell'ambito della relativa posizione economica
				select xgrad
				replace xgrad.i09   with xgrad.decarriera
           *--  J: Anzianit di inquadramento dei ruoli del MAE nel profilo professionale di appartenenza nell'ambito della relativa posizione economica        
				select xgrad
				replace xgrad.i10   with xgrad.druolimae   
        
*!*	           *--  K: 1) Domanda di Assegnazione Congiunta
*!*	           *       2) Ricongiungimento del dipendente con coniuge in servizio all'estero
*!*					select xgrad
*!*					replace xgrad.i11   with 0
*!*					if ( xgrad.cric = 1 or xgrad.ac_flag = 1 ) then
*!*					   select xgrad
*!*					   replace xgrad.i11   with 1
*!*					endif        

           *--  K: 1) Domanda di Assegnazione Congiunta
				select xgrad
				replace xgrad.i11   with 0
				if (  xgrad.ac_flag = 1 ) then
				   select xgrad
				   replace xgrad.i11   with 1
				endif        

           *--  K1:1) Ricongiungimento del dipendente con coniuge in servizio all'estero
				if xgrad.pjob > 4 then
				   select xgrad
				   replace xgrad.i11   with 1
				endif        


           *--  L: Provenienza da servizio a contratto ai sensi dell'art.152 del DPR  n.18/67
				select xgrad
				replace xgrad.i12   with 0
				if ( not empty(xgrad.dapregctr) ) then				   
				   if  ( date() > xgrad.dapregctr ) then
				       select xgrad
				       replace xgrad.i12   with 1				      
				   endif       
				endif       
				 
           *--  M:  1) Anzianit di Comando 
           *        2) Anzianit di Collocamento Fuori Ruolo
				select xgrad
				replace xgrad.i13   with xgrad.dapregcom
           
           
           *--  M1: Anzianit nei ruoli presso l'Amministrazione di provenienza
				select xgrad
				replace xgrad.i14   with xgrad.dammprov
        
           *-- N: Giorni Permannenza MAE
               select xgrad
               replace xgrad.gpm   with xgrad.tggmae &&- xgrad.gg15com
               replace xgrad.i15   with xgrad.gpm

           *-- O: Posizione nel bollettino MAE
               select xgrad
               replace xgrad.i16   with xgrad.bollettino
        

           *-- R: Solo per sedi Romane
           *      - non aver mai prestato servizio nelle sedi romane
           *      - non aver mai prestato servizio all'estero nel quinquennio precedente
               select xgrad
               replace xgrad.i19   with xgrad.msr
               replace xgrad.i20   with xgrad.pacp5a


           *-- Giorni Permannenza MAE
               select xgrad
               replace xgrad.gpm   with xgrad.tggmae - xgrad.gg15com
               
           *-- Profilo APP Candidato
               select profilo
               locate for profilo.ppcode = xgrad.ppcode
               if found("profilo") then
                  select xgrad
                  replace xgrad.td_pfdesc with profilo.pfdesc
               endif
               
            *-- Lingue Candidato
			    m.ListLingue = ""
				if ( not len(alltrim(xgrad.lingua01)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+ substr(alltrim(xgrad.lingua01),1,3)+"/"+GetShortLevelLanguage(xgrad.livello01)+"  "
				endif

				if ( not len(alltrim(xgrad.lingua02)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+ substr(alltrim(xgrad.lingua02),1,3)+"/"+GetShortLevelLanguage(xgrad.livello02)+"  "
				endif

				if ( not len(alltrim(xgrad.lingua03)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+ substr(alltrim(xgrad.lingua03),1,3)+"/"+GetShortLevelLanguage(xgrad.livello03)+"  "
				endif

				if ( not len(alltrim(xgrad.lingua04)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+ substr(alltrim(xgrad.lingua04),1,3)+"/"+GetShortLevelLanguage(xgrad.livello04)+"  "
				endif

				if ( not len(alltrim(xgrad.lingua05)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+ substr(alltrim(xgrad.lingua05),1,3)+"/"+GetShortLevelLanguage(xgrad.livello05)+"  "
				endif
                select xgrad
                replace xgrad.td_lingue with m.ListLingue

            *-- Corsi Candidato
				m.ListCorsi = ""

				if xgrad.corso01 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[02]) 
				endif
				if xgrad.corso02 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[03]) 
				endif
				if xgrad.corso03 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[04]) 
				endif
				if xgrad.corso04 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[05]) 
				endif
				if xgrad.corso05 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[06]) 
				endif
				if xgrad.corso06 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[07]) 
				endif
				if xgrad.corso07 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[08]) 
				endif
				if xgrad.corso08 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[09]) 
				endif
				if xgrad.corso09 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[10]) 
				endif
				if xgrad.corso10 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[11]) 
				endif
				if xgrad.corso11 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[12]) 
				endif
				if xgrad.corso12 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[13]) 
				endif
                select xgrad
                replace xgrad.td_corsi with m.ListCorsi


            *-- Curriculum Candidato
				m.ListCurriculum = ""

				if xgrad.curr01 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[02]) 
				endif
				if xgrad.curr02 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[03]) 
				endif
				if xgrad.curr03 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[04]) 
				endif
				if xgrad.curr04 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[05]) 
				endif
				if xgrad.curr05 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[06]) 
				endif
				if xgrad.curr06 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[07]) 
				endif
				if xgrad.curr07 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[08]) 
				endif
				if xgrad.curr08 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[09]) 
				endif
				if xgrad.curr09 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[10]) 
				endif
				if xgrad.curr10 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[11]) 
				endif
				if xgrad.curr11 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[12]) 
				endif
				if xgrad.curr12 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[13]) 
				endif
				if xgrad.curr13 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[14]) 
				endif
				if xgrad.curr14 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[15]) 
				endif
				if xgrad.curr15 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[16]) 
				endif 
				if xgrad.curr16 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[17]) 
				endif 				
                select xgrad
                replace xgrad.td_curr with  m.ListCurriculum

				          
           *-- Lingue Posto
               m.zx_lingue = ""
               if not len(alltrim(xgrad.tr_ling01)) = 0 then
                  m.zx_lingue =m.zx_lingue+substr(alltrim(xgrad.tr_ling01),1,3)+"/"+GetShortLevelLanguage(xgrad.tr_liv01)+" "+alltrim(xgrad.log01)+" "
               endif
               if not len(alltrim(xgrad.tr_ling02)) = 0 then
                  m.zx_lingue =m.zx_lingue+substr(alltrim(xgrad.tr_ling02),1,3)+"/"+GetShortLevelLanguage(xgrad.tr_liv02)+" "+alltrim(xgrad.log02)+" "
               endif
               if not len(alltrim(xgrad.tr_ling03)) = 0 then
                  m.zx_lingue =m.zx_lingue+substr(alltrim(xgrad.tr_ling03),1,3)+"/"+GetShortLevelLanguage(xgrad.tr_liv03)+" "+alltrim(xgrad.log03)+" "
               endif
               if not len(alltrim(xgrad.tr_ling04)) = 0 then
                  m.zx_lingue =m.zx_lingue+substr(alltrim(xgrad.tr_ling04),1,3)+"/"+GetShortLevelLanguage(xgrad.tr_liv04)+" "+alltrim(xgrad.log04)+" "
               endif
               if not len(alltrim(xgrad.tr_ling05)) = 0 then
                  m.zx_lingue =m.zx_lingue+substr(alltrim(xgrad.tr_ling05),1,3)+"/"+GetShortLevelLanguage(xgrad.tr_liv05)
               endif
               select xgrad
               replace xgrad.tr_lingue with m.zx_lingue
         
         
           *-- Storico 
	            m.zx_matricola = xgrad.matricola
	            if used("czstorico") then
	               select czstorico
	               use
	            endif
	            
	            select * ;
	              from xstorico ;
	             where xstorico.matricola = m.zx_matricola ;
	            order by xstorico.dataasspos asc           ;
	            into cursor czstorico
	            
	            m.zx_indice = 1
	            select czstorico
	            go top
	            
	            scan
	               
	               do case
	                  case m.zx_indice = 1
	                       m.zx_indice = 2
	                       select xgrad
	                       replace xgrad.pse01 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)
	                       
	                  case m.zx_indice = 2
	                       m.zx_indice = 3
	                       select xgrad
	                       replace xgrad.pse02 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 3
	                       m.zx_indice = 4
	                       select xgrad
	                       replace xgrad.pse03 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 4
	                       m.zx_indice = 5
	                       select xgrad
	                       replace xgrad.pse04 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 5
	                       m.zx_indice = 6
	                       select xgrad
	                       replace xgrad.pse05 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 6
	                       m.zx_indice = 7
	                       select xgrad
	                       replace xgrad.pse06 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 7
	                       m.zx_indice = 8
	                       select xgrad
	                       replace xgrad.pse07 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 8
	                       m.zx_indice = 9
	                       select xgrad
	                       replace xgrad.pse08 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 9
	                       m.zx_indice = 10
	                       select xgrad
	                       replace xgrad.pse09 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 10
	                       select xgrad
	                       replace xgrad.pse010 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	               endcase
	            
	               select czstorico
	            endscan 
                 
            *-- Rango
                select xgrad
                replace xgrad.shortrango with GetDesShortRango(xgrad.rango) 
            
            *-- Ufficio Attuale
				if  upper(alltrim(xgrad.em))=="E" then 
					if xgrad.ntp_rif = 0 then
					   m.zx_sedeadsc = "Sede non presente."
					else
					   if seek(xgrad.ntp_rif,"esede","ntp_ide") then
					      m.zx_sedeadsc =  alltrim(esede.rango)+" - "+alltrim(esede.sede)
					   else
					      m.zx_sedeadsc = "Sede non trovata."
					   endif
					endif   
				else 
				    m.zx_sedeadsc = xgrad.sedea_dsc
				endif 
				select xgrad
				replace xgrad.sede_att with m.zx_sedeadsc
        
           select xgrad
        endscan
        


    *-- Ordering
*!*	        do case
*!*	           case thisform.OrderType.Value = 1
*!*	                M.DynaTitle   = M.DynaTitle+ " ordinate per Protocollo "
*!*			        select *       ;
*!*			          from xgrad   ;
*!*			        order by xgrad.protocollo  asc,  ;
*!*			                 xgrad.cognome     asc,  ;
*!*			                 xgrad.nome        asc,  ;
*!*			                 xgrad.pref        asc   ;                 
*!*			         into cursor lt_dom_complete 
*!*			               
*!*	           case thisform.OrderType.Value = 2
*!*	                M.DynaTitle   = M.DynaTitle+ " ordinate per Nominativo "
*!*	           
*!*			        select *       ;
*!*			          from xgrad   ;
*!*			        order by xgrad.cognome  asc, ;                 
*!*			                 xgrad.nome     asc, ;                 
*!*			                 xgrad.pref     asc  ;                 
*!*			         into cursor lt_dom_complete       

*!*	        endcase


    *-- Create Graduatoria
        if used("glist") then
           select glist
           use
        endif
        
        if  "ORDINARIA"==upper(alltrim(m.sPbls_Tipo)) then       
	        if m.pca_gavv5aa   = 0 then
		        select *       ;
		          from xgrad   ;
		        order by xgrad.nsedia      asc,   ;     
		                 xgrad.sricev      desc,  ; && Candidatura: Valida, Non Valida
		                 xgrad.i01         asc,   ;
		                 xgrad.i02         desc,  ;
		                 xgrad.i03         desc,  ;
		                 xgrad.i04         desc,  ;
		                 xgrad.i05         desc,  ;
		                 xgrad.i06         desc,  ;
		                 xgrad.i07         desc,  ;
		                 xgrad.i08         desc,  ;
		                 xgrad.i09         asc,   ;
		                 xgrad.i10         asc,   ;
		                 xgrad.i11         desc,  ;
		                 xgrad.i12         desc,  ;
		                 xgrad.i13         asc,   ; && Data Pregressa Comando
		                 xgrad.i14         asc,   ;
		                 xgrad.i15         desc,  ;
		                 xgrad.i19         desc,  ;
		                 xgrad.i20         desc,  ;                 
		                 xgrad.i16         asc    ;
		         into table (m.PathFolderCache+"glist.dbf") 
	      else
		        select *       ;
		          from xgrad   ;
		        order by xgrad.nsedia      asc,   ;     
		                 xgrad.sricev      desc,  ; && Candidatura: Valida, Non Valida
		                 xgrad.i01         asc,   ;
		                 xgrad.i02         desc,  ;
		                 xgrad.i03         desc,  ;
		                 xgrad.i04         desc,  ;
		                 xgrad.i05         desc,  ;
		                 xgrad.i06         desc,  ;
	                     ;
	                     xgrad.avvuff      desc,  ; && Riassegnazioni
	                     xgrad.pacp5a      desc,  ; 
	                     ;
		                 xgrad.i08         desc,  ;
		                 xgrad.i09         asc,   ;
		                 xgrad.i10         asc,   ;
		                 xgrad.i11         desc,  ;
		                 xgrad.i12         desc,  ;
		                 xgrad.i13         asc,   ; && Data Pregressa Comando
		                 xgrad.i14         asc,   ;
		                 xgrad.i15         desc,  ;
		                 xgrad.i19         desc,  ;
		                 xgrad.i20         desc,  ;                 
		                 xgrad.i16         asc    ;
		         into table (m.PathFolderCache+"glist.dbf") 
	      endif
	      
        else &&  NOT "ORDINARIA"$upper(alltrim(m.sPbls_Tipo)) then       
        
            do case
               case m.pca_gavv5aa  = 0  and m.pca_gbggmae = 0
			        select *       ;
			          from xgrad   ;
			        order by xgrad.nsedia      asc,   ;     
			                 xgrad.sricev      desc,  ; && Candidatura: Valida, Non Valida
			                 xgrad.i01         asc,   ;
			                 xgrad.i02         desc,  ;
			                 xgrad.i03         desc,  ;
			                 ;
			                 xgrad.i15         desc,  ;
			                 ;
			                 xgrad.i04         desc,  ;
			                 xgrad.i05         desc,  ;
			                 xgrad.i06         desc,  ;
			                 xgrad.i07         desc,  ;
			                 xgrad.i08         desc,  ;
			                 xgrad.i09         asc,   ;
			                 xgrad.i10         asc,   ;
			                 xgrad.i11         desc,  ;
			                 xgrad.i12         desc,  ;
			                 xgrad.i13         asc,   ; && Data Pregressa Comando
			                 xgrad.i14         asc,   ;
			                 ;
			                 xgrad.i19         desc,  ;
			                 xgrad.i20         desc,  ;                 
			                 xgrad.i16         asc    ;
			         into table (m.PathFolderCache+"glist.dbf") 
			         
               case m.pca_gavv5aa  = 0  and m.pca_gbggmae = 1
			        select *       ;
			          from xgrad   ;
			        order by xgrad.nsedia      asc,   ;     
			                 xgrad.sricev      desc,  ; && Candidatura: Valida, Non Valida
			                 xgrad.i01         asc,   ;
			                 xgrad.i02         desc,  ;
			                 xgrad.i03         desc,  ;
			                 xgrad.i04         desc,  ;
			                 ;
			                 xgrad.i15         desc,  ;
			                 ;			                 
			                 xgrad.i05         desc,  ;
			                 xgrad.i06         desc,  ;
			                 xgrad.i07         desc,  ;
			                 xgrad.i08         desc,  ;
			                 xgrad.i09         asc,   ;
			                 xgrad.i10         asc,   ;
			                 xgrad.i11         desc,  ;
			                 xgrad.i12         desc,  ;
			                 xgrad.i13         asc,   ; && Data Pregressa Comando
			                 xgrad.i14         asc,   ;
			                 ;
			                 xgrad.i19         desc,  ;
			                 xgrad.i20         desc,  ;                 
			                 xgrad.i16         asc    ;
			         into table (m.PathFolderCache+"glist.dbf") 
			         
               case m.pca_gavv5aa  = 1  and m.pca_gbggmae = 0
			        select *       ;
			          from xgrad   ;
			        order by xgrad.nsedia      asc,   ;     
			                 xgrad.sricev      desc,  ; && Candidatura: Valida, Non Valida
			                 xgrad.i01         asc,   ;
			                 xgrad.i02         desc,  ;
			                 xgrad.i03         desc,  ;
			                 ;
			                 xgrad.i15         desc,  ;
			                 ;
			                 xgrad.i04         desc,  ;
			                 xgrad.i05         desc,  ;
			                 xgrad.i06         desc,  ;
		                     ;
		                     xgrad.avvuff      desc,  ; && Riassegnazioni
		                     xgrad.pacp5a      desc,  ; 
		                     ;
			                 xgrad.i08         desc,  ;
			                 xgrad.i09         asc,   ;
			                 xgrad.i10         asc,   ;
			                 xgrad.i11         desc,  ;
			                 xgrad.i12         desc,  ;
			                 xgrad.i13         asc,   ; && Data Pregressa Comando
			                 xgrad.i14         asc,   ;
			                 ;
			                 xgrad.i19         desc,  ;
			                 xgrad.i20         desc,  ;                 
			                 xgrad.i16         asc    ;
			         into table (m.PathFolderCache+"glist.dbf") 
			         
               case m.pca_gavv5aa  = 1  and m.pca_gbggmae = 1
			        select *       ;
			          from xgrad   ;
			        order by xgrad.nsedia      asc,   ;     
			                 xgrad.sricev      desc,  ; && Candidatura: Valida, Non Valida
			                 xgrad.i01         asc,   ;
			                 xgrad.i02         desc,  ;
			                 xgrad.i03         desc,  ;
			                 xgrad.i04         desc,  ;
			                 ;
			                 xgrad.i15         desc,  ;
			                 ;			                 
			                 xgrad.i05         desc,  ;
			                 xgrad.i06         desc,  ;
		                     ;
		                     xgrad.avvuff      desc,  ; && Riassegnazioni
		                     xgrad.pacp5a      desc,  ; 
		                     ;
			                 xgrad.i08         desc,  ;
			                 xgrad.i09         asc,   ;
			                 xgrad.i10         asc,   ;
			                 xgrad.i11         desc,  ;
			                 xgrad.i12         desc,  ;
			                 xgrad.i13         asc,   ; && Data Pregressa Comando
			                 xgrad.i14         asc,   ;
			                 ;
			                 xgrad.i19         desc,  ;
			                 xgrad.i20         desc,  ;                 
			                 xgrad.i16         asc    ;
			         into table (m.PathFolderCache+"glist.dbf") 
			         
            endcase
        endif  &&"ORDINARIA"$upper(alltrim(m.sPbls_Tipo)) then       


      select glist
       go top
       m.KeyBreaking = glist.nsedia
       m.Progressive = 0
       scan
          if m.KeyBreaking = glist.nsedia then
             m.Progressive = m.Progressive +1
             select glist
             replace glist.ngrad with m.Progressive
          else
             m.KeyBreaking = glist.nsedia
             m.Progressive = 0             
             m.Progressive = m.Progressive +1
             select glist
             replace glist.ngrad with m.Progressive
          endif
           
          select glist
       endscan
*!*	      
*!*	      
*!*	      
*!*	      
*!*	       if used("cxpas") then
*!*	          select cxpas
*!*	          use
*!*	       endif   
*!*	          
*!*	       select * ;
*!*	         from lt_graduatorie ;
*!*	       into cursor cxpas
*!*	       
*!*	       m.jzxMatricola = 0  
*!*	       select lt_graduatorie  
*!*	       go top
*!*	       scan
*!*	       
*!*	          m.jzxMatricola = lt_graduatorie.matricola  
*!*	          do form InfoMsg.scx with "Matricola "+alltrim(str(lt_graduatorie.matricola))+" ..."
*!*	          if used("cxpaslist") then
*!*	             select cxpaslist
*!*	             use
*!*	          endif
*!*	          
*!*	          select *      ;
*!*	            from cxpas  ;
*!*	           where cxpas.matricola = m.jzxMatricola ;
*!*	          into cursor cxpaslist
*!*	          
*!*	          select cxpaslist
*!*	          go top
*!*	          scan 
*!*	             
*!*	             if ( not cxpaslist.nsedia = lt_graduatorie.nsedia ) then
*!*	                select lt_graduatorie
*!*	                replace lt_graduatorie.pas with alltrim(lt_graduatorie.pas)+ ;
*!*	                                                alltrim(str(cxpaslist.pref))+"/"+;
*!*	                                                alltrim(cxpaslist.shortrango)+" "+;                                                
*!*	                                                alltrim(cxpaslist.sede)+"/S:"+;
*!*	                                                alltrim(str(cxpaslist.nsedia))+chr(13)
*!*	             endif
*!*	             
*!*	             select cxpaslist
*!*	          endscan
*!*	          
*!*	          release windows InfoMsg
*!*	          select lt_graduatorie  
*!*	       endscan
            
   *-- Get Totale Sedi
  
   *-- Information Retrival
       
   
          
   *- Ordinamento

      release windows InfoMsg