
lparameters m.xiVisionType, m.xiPbls_rif, m.xiProtocollo

* M.xiVisionType   : PREVIEW or PRINT
* Rest by Print Communication Area

*-- SECTION SERVICE
    LOCAL M.DynaTitle, M.HeaderLabel, M.FooterLabel
	M.DynaTitle   = "Anaggrafico"
	M.HeaderLabel = MEMORY.PHEADER
	M.FooterLabel = MEMORY.PFOOTER

	PUBLIC M.xQuery
	M.xQuery  = "" 
	M.xReport = ""
	
	
*-- AREA INTELLIGENCE
 
    *-- Set Up cache folder
	    public m.PathFolderCache as String
	    m.PathFolderCache = m.GS_LRP+"cache\"+alltrim(m.gs_pbls_des)+"\" 
	    =MKDIR(JUSTPATH(ALLTRIM(m.PathFolderCache)))
	    
   *-- Information Retrival
       public m.pca_TNDomande as Integer
       m.pca_TNDomande = 0
       
       public m.pca_ITNDomande as Integer
       m.pca_ITNDomande = 0
       
       if used("ctnd") then
          select ctnd
          use
       endif
       select count(*) as tnd ;
         from Tdomanda        ;
        where ( not deleted("tdomanda") )         ;
          and tdomanda.pbls_rif =  m.pca_pbls_rif ;
       into cursor ctnd
       m.pca_TNDomande =ctnd.tnd
        
       if used("XDLista") then
          select XDLista
          use
       endif
       if used("XDPosto") then
          select XDPosto
          use
       endif
       if used("XStorico") then
          select XStorico
          use
       endif

       *-- Base Entity
           do case
              case thisform.passListType.Value = 1
                   do case
                      case thisform.wirric.Value = 1
					       select tdomanda.matricola,       ;
					              tdomanda.cognome,         ;
					              tdomanda.nome,            ;
					              tdomanda.sesso,           ;
					              tdomanda.dnascita,        ;
					              tdomanda.qualifica,       ;
					              tdomanda.ppdesc,          ;
					              tdomanda.ppcode,          ;
					              space(080) as td_pfdesc,  ;
					              space(080) as sede_att,   ;
					              tdomanda.pm_dsz1,         ;		
					              tdomanda.pm_dsz2,         ;	
					              tdomanda.pm_code1,        ;
					              tdomanda.pm_code2,        ; 				              						              	
					              tdomanda.ntp_rif,         ;		                            
					              tdomanda.sedea_dal,       ;
					              tdomanda.sedea_dsc,       ;
					              tdomanda.em,              ;
					              tdomanda.protocollo,      ;
					              tdomanda.enote,           ;
					              tdomanda.wnote,           ;
					              space(200) as td_lingue,  ;
					              space(200) as td_curr,    ;
					              space(200) as td_corsi,   ;
					              space(254) as pas,        ;
					              0000       as ngrad,      ;
					              tdomanda.lingua01,        ;
					              tdomanda.lingua02,        ;
					              tdomanda.lingua03,        ;
					              tdomanda.lingua04,        ;
					              tdomanda.lingua05,        ;
					              tdomanda.lingua06,        ;
					              tdomanda.livello01,       ;
					              tdomanda.livello02,       ;
					              tdomanda.livello03,       ;
					              tdomanda.livello04,       ;
					              tdomanda.livello05,       ;
					              tdomanda.livello06,       ;
					              tdomanda.corso01,         ;
					              tdomanda.corso02,         ;
					              tdomanda.corso03,         ;
					              tdomanda.corso04,         ;
					              tdomanda.corso05,         ;
					              tdomanda.corso06,         ;
					              tdomanda.corso07,         ;
					              tdomanda.corso08,         ;
					              tdomanda.corso09,         ;
					              tdomanda.corso10,         ;
					              tdomanda.corso11,         ;
					              tdomanda.corso12,         ;
				                  tdomanda.curr01,          ;	              
				                  tdomanda.curr02,          ;	              
				                  tdomanda.curr03,          ;	              
				                  tdomanda.curr04,          ;	              
				                  tdomanda.curr05,          ;	              
				                  tdomanda.curr06,          ;	              
				                  tdomanda.curr07,          ;	              
				                  tdomanda.curr08,          ;	              
				                  tdomanda.curr09,          ;	              
				                  tdomanda.curr10,          ;	              
				                  tdomanda.curr11,          ;	              
				                  tdomanda.curr12,          ;	              
				                  tdomanda.curr13,          ;	              
				                  tdomanda.curr14,          ;	
				                  tdomanda.curr15,          ;
				                  tdomanda.curr16,          ;	
				                  tdomanda.curr17,          ;	              
				                  tdomanda.nslng01,         ;	              
				                  tdomanda.nslng02,         ;	              
				                  tdomanda.nslng03,         ;	              
				                  tdomanda.nslng04,         ;	              
				                  tdomanda.nslng05,         ;	                                                                                      
				                  tdomanda.bollettino,      ;	              
				                  tdomanda.druolimae,       ;	              
				                  tdomanda.decarriera,      ;	              
				                  tdomanda.deprofilo,       ;	 
				                  tdomanda.dapregctr,       ;	
				                  tdomanda.dapregcom,       ;	
				                  tdomanda.dammprov,        ;	
				                  tdomanda.dcessmae,        ;	
				                  tdomanda.dataestero,      ;	
				                  tdomanda.ggfr,            ;	  
				                  tdomanda.drcomfr,         ;	  
				                  tdomanda.tggmae,          ;	                          
				                  tdomanda.chb,             ;	              
				                  tdomanda.cha,             ;	              
				                  tdomanda.cric,            ;	              
				                  tdomanda.turn,            ;	              
				                  tdomanda.eu5a,            ;	
				                  tdomanda.psb,             ;	
				                  tdomanda.gg15com,         ;	              
				                  tdomanda.ggpt,            ;	              
				                  tdomanda.ggas,            ;	              
				                  tdomanda.ggasp,           ;	              
				                  tdomanda.gric,            ;
				                  tdomanda.modirr,          ;	
				                  ;
				                  space(100) as pse01,   ;
				                  space(100) as pse02,   ;
				                  space(100) as pse03,   ;
				                  space(100) as pse04,   ;
				                  space(100) as pse05,   ;
				                  space(100) as pse06,   ;
				                  space(100) as pse07,   ;
				                  space(100) as pse08,   ;  
				                  space(100) as pse09,   ;  
				                  space(100) as pse10,   ;  
				                  ;
				                  space(230)   as cand01,   ;	                                                         
				                  space(230)   as cand02,   ;	                                                         
				                  space(230)   as cand03,   ;	                                                         
				                  space(230)   as cand04,   ;	                                                         
				                  space(230)   as cand05,   ;	                                                         
				                  space(230)   as cand06,   ;	                                                         
				                  space(230)   as cand07,   ;	                                                         
				                  space(230)   as cand08,   ;	                                                         
				                  space(230)   as cand09,   ;	                                                         
				                  space(230)   as cand10,   ;	                                                         
				                  space(230)   as cand11,   ;	                                                         
				                  space(230)   as cand12,   ;	                                                         
				                  space(230)   as cand13,   ;	                                                         
				                  space(230)   as cand14,   ;	                                                         
				                  space(230)   as cand15,   ;	                                                         
				                  space(230)   as cand16,   ;	                                                         
				                  space(230)   as cand17,    ;	                                                         
				                  space(230)   as cand18,   ;	                                                         
				                  space(230)   as cand19,   ;	                                                         
				                  space(230)   as cand20,   ;	                                                         
				                  space(230)   as cand21,   ;	                                                         
				                  space(230)   as cand22,   ;	                                                         
				                  space(230)   as cand23,   ;	                                                         
				                  space(230)   as cand24,   ;	                                                         
				                  space(230)   as cand25,   ;	                                                         
				                  space(230)   as cand26,   ;	                                                         
				                  space(230)   as cand27,   ;	                                                         
				                  space(230)   as cand28,   ;	                                                         
				                  space(230)   as cand29,   ;	                                                         
				                  space(230)   as cand30    ;	                                                         
					         from tdomanda ;
					        where ( not deleted("tdomanda") )              ;
					          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
					          and tdomanda.gric     =  1                   ;                                                                                 
					        order by tdomanda.cognome asc,                 ;
					                 tdomanda.nome    asc                  ; 
					        into table (m.PathFolderCache+"XDLista.dbf") 
					        
                      otherwise
					       select tdomanda.matricola,       ;
					              tdomanda.cognome,         ;
					              tdomanda.nome,            ;
					              tdomanda.sesso,           ;
					              tdomanda.dnascita,        ;
					              tdomanda.qualifica,       ;
					              tdomanda.ppdesc,          ;
					              tdomanda.ppcode,          ;
					              space(080) as td_pfdesc,  ;
					              space(080) as sede_att,   ;
					              tdomanda.pm_dsz1,         ;		
					              tdomanda.pm_dsz2,         ;		
					              tdomanda.pm_code1,        ;
					              tdomanda.pm_code2,        ; 				              						              
					              tdomanda.ntp_rif,         ;		                            
					              tdomanda.sedea_dal,       ;
					              tdomanda.sedea_dsc,       ;
					              tdomanda.em,              ;
					              tdomanda.protocollo,      ;
					              tdomanda.enote,           ;
					              tdomanda.wnote,           ;
					              space(200) as td_lingue,  ;
					              space(200) as td_curr,    ;
					              space(200) as td_corsi,   ;
					              space(254) as pas,        ;
					              0000       as ngrad,      ;
					              tdomanda.lingua01,        ;
					              tdomanda.lingua02,        ;
					              tdomanda.lingua03,        ;
					              tdomanda.lingua04,        ;
					              tdomanda.lingua05,        ;
					              tdomanda.lingua06,        ;
					              tdomanda.livello01,       ;
					              tdomanda.livello02,       ;
					              tdomanda.livello03,       ;
					              tdomanda.livello04,       ;
					              tdomanda.livello05,       ;
					              tdomanda.livello06,       ;
					              tdomanda.corso01,         ;
					              tdomanda.corso02,         ;
					              tdomanda.corso03,         ;
					              tdomanda.corso04,         ;
					              tdomanda.corso05,         ;
					              tdomanda.corso06,         ;
					              tdomanda.corso07,         ;
					              tdomanda.corso08,         ;
					              tdomanda.corso09,         ;
					              tdomanda.corso10,         ;
					              tdomanda.corso11,         ;
					              tdomanda.corso12,         ;
				                  tdomanda.curr01,          ;	              
				                  tdomanda.curr02,          ;	              
				                  tdomanda.curr03,          ;	              
				                  tdomanda.curr04,          ;	              
				                  tdomanda.curr05,          ;	              
				                  tdomanda.curr06,          ;	              
				                  tdomanda.curr07,          ;	              
				                  tdomanda.curr08,          ;	              
				                  tdomanda.curr09,          ;	              
				                  tdomanda.curr10,          ;	              
				                  tdomanda.curr11,          ;	              
				                  tdomanda.curr12,          ;	              
				                  tdomanda.curr13,          ;	              
				                  tdomanda.curr14,          ;	
				                  tdomanda.curr15,          ;
				                  tdomanda.curr16,          ;	
				                  tdomanda.curr17,          ;	              
				                  tdomanda.nslng01,         ;	              
				                  tdomanda.nslng02,         ;	              
				                  tdomanda.nslng03,         ;	              
				                  tdomanda.nslng04,         ;	              
				                  tdomanda.nslng05,         ;	                                                                                      
				                  tdomanda.bollettino,      ;	              
				                  tdomanda.druolimae,       ;	              
				                  tdomanda.decarriera,      ;	              
				                  tdomanda.deprofilo,       ;	 
				                  tdomanda.dapregctr,       ;	
				                  tdomanda.dapregcom,       ;	
				                  tdomanda.dammprov,        ;	
				                  tdomanda.dcessmae,        ;	
				                  tdomanda.dataestero,      ;	
				                  tdomanda.ggfr,            ;	  
				                  tdomanda.drcomfr,         ;	  
				                  tdomanda.tggmae,          ;	                          
				                  tdomanda.chb,             ;	              
				                  tdomanda.cha,             ;	              
				                  tdomanda.cric,            ;	              
				                  tdomanda.turn,            ;	              
				                  tdomanda.eu5a,            ;	
				                  tdomanda.psb,             ;	
				                  tdomanda.gg15com,         ;	              
				                  tdomanda.ggpt,            ;	              
				                  tdomanda.ggas,            ;	              
				                  tdomanda.ggasp,           ;	              
				                  tdomanda.gric,            ;	
				                  tdomanda.modirr,          ;					                  
				                  ;
				                  space(100) as pse01,   ;
				                  space(100) as pse02,   ;
				                  space(100) as pse03,   ;
				                  space(100) as pse04,   ;
				                  space(100) as pse05,   ;
				                  space(100) as pse06,   ;
				                  space(100) as pse07,   ;
				                  space(100) as pse08,   ;  
				                  space(100) as pse09,   ;  
				                  space(100) as pse10,   ;  
				                  ;
				                  space(230)   as cand01,   ;	                                                         
				                  space(230)   as cand02,   ;	                                                         
				                  space(230)   as cand03,   ;	                                                         
				                  space(230)   as cand04,   ;	                                                         
				                  space(230)   as cand05,   ;	                                                         
				                  space(230)   as cand06,   ;	                                                         
				                  space(230)   as cand07,   ;	                                                         
				                  space(230)   as cand08,   ;	                                                         
				                  space(230)   as cand09,   ;	                                                         
				                  space(230)   as cand10,   ;	                                                         
				                  space(230)   as cand11,   ;	                                                         
				                  space(230)   as cand12,   ;	                                                         
				                  space(230)   as cand13,   ;	                                                         
				                  space(230)   as cand14,   ;	                                                         
				                  space(230)   as cand15,   ;	                                                         
				                  space(230)   as cand16,   ;	                                                         
				                  space(230)   as cand17,    ;	                                                         
				                  space(230)   as cand18,   ;	                                                         
				                  space(230)   as cand19,   ;	                                                         
				                  space(230)   as cand20,   ;	                                                         
				                  space(230)   as cand21,   ;	                                                         
				                  space(230)   as cand22,   ;	                                                         
				                  space(230)   as cand23,   ;	                                                         
				                  space(230)   as cand24,   ;	                                                         
				                  space(230)   as cand25,   ;	                                                         
				                  space(230)   as cand26,   ;	                                                         
				                  space(230)   as cand27,   ;	                                                         
				                  space(230)   as cand28,   ;	                                                         
				                  space(230)   as cand29,   ;	                                                         
				                  space(230)   as cand30    ;	                                                         
					         from tdomanda ;
					        where ( not deleted("tdomanda") )              ;
					          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
					        order by tdomanda.cognome asc,                 ;
					                 tdomanda.nome    asc                  ; 
					        into table (m.PathFolderCache+"XDLista.dbf") 
                   endcase

			        
              case thisform.passListType.Value = 2
              
                   do case
                   *- Senza gli Irricevibili
                      case thisform.wirric.Value = 1
					       select tdomanda.matricola,       ;
					              tdomanda.cognome,         ;
					              tdomanda.nome,            ;
					              tdomanda.sesso,           ;
					              tdomanda.dnascita,        ;
					              tdomanda.qualifica,       ;
					              tdomanda.ppdesc,          ;
					              tdomanda.ppcode,          ;
					              space(080) as td_pfdesc,  ;
					              space(080) as sede_att,   ;
					              tdomanda.pm_dsz1,         ;		
					              tdomanda.pm_dsz2,         ;
					              tdomanda.pm_code1,        ;
					              tdomanda.pm_code2,        ; 				              						              		
					              tdomanda.ntp_rif,         ;		                            
					              tdomanda.sedea_dal,       ;
					              tdomanda.sedea_dsc,       ;
					              tdomanda.em,              ;
					              tdomanda.protocollo,      ;
					              tdomanda.enote,           ;
					              tdomanda.wnote,           ;
					              space(200) as td_lingue,  ;
					              space(200) as td_curr,    ;
					              space(200) as td_corsi,   ;
					              space(254) as pas,        ;
					              0000       as ngrad,      ;
					              tdomanda.lingua01,        ;
					              tdomanda.lingua02,        ;
					              tdomanda.lingua03,        ;
					              tdomanda.lingua04,        ;
					              tdomanda.lingua05,        ;
					              tdomanda.lingua06,        ;
					              tdomanda.livello01,       ;
					              tdomanda.livello02,       ;
					              tdomanda.livello03,       ;
					              tdomanda.livello04,       ;
					              tdomanda.livello05,       ;
					              tdomanda.livello06,       ;
					              tdomanda.corso01,         ;
					              tdomanda.corso02,         ;
					              tdomanda.corso03,         ;
					              tdomanda.corso04,         ;
					              tdomanda.corso05,         ;
					              tdomanda.corso06,         ;
					              tdomanda.corso07,         ;
					              tdomanda.corso08,         ;
					              tdomanda.corso09,         ;
					              tdomanda.corso10,         ;
					              tdomanda.corso11,         ;
					              tdomanda.corso12,         ;
				                  tdomanda.curr01,          ;	              
				                  tdomanda.curr02,          ;	              
				                  tdomanda.curr03,          ;	              
				                  tdomanda.curr04,          ;	              
				                  tdomanda.curr05,          ;	              
				                  tdomanda.curr06,          ;	              
				                  tdomanda.curr07,          ;	              
				                  tdomanda.curr08,          ;	              
				                  tdomanda.curr09,          ;	              
				                  tdomanda.curr10,          ;	              
				                  tdomanda.curr11,          ;	              
				                  tdomanda.curr12,          ;	              
				                  tdomanda.curr13,          ;	              
				                  tdomanda.curr14,          ;	
				                  tdomanda.curr15,          ;
				                  tdomanda.curr16,          ;	
				                  tdomanda.curr17,          ;	              
				                  tdomanda.nslng01,         ;	              
				                  tdomanda.nslng02,         ;	              
				                  tdomanda.nslng03,         ;	              
				                  tdomanda.nslng04,         ;	              
				                  tdomanda.nslng05,         ;	                                                                                      
				                  tdomanda.bollettino,      ;	              
				                  tdomanda.druolimae,       ;	              
				                  tdomanda.decarriera,      ;	              
				                  tdomanda.deprofilo,       ;	 
				                  tdomanda.dapregctr,       ;	
				                  tdomanda.dapregcom,       ;	
				                  tdomanda.dammprov,        ;	
				                  tdomanda.dcessmae,        ;	
				                  tdomanda.dataestero,      ;	
				                  tdomanda.ggfr,            ;	  
				                  tdomanda.drcomfr,         ;	  
				                  tdomanda.tggmae,          ;	                          
				                  tdomanda.chb,             ;	              
				                  tdomanda.cha,             ;	              
				                  tdomanda.cric,            ;	              
				                  tdomanda.turn,            ;	              
				                  tdomanda.eu5a,            ;	
				                  tdomanda.psb,             ;	
				                  tdomanda.gg15com,         ;	              
				                  tdomanda.ggpt,            ;	              
				                  tdomanda.ggas,            ;	              
				                  tdomanda.ggasp,           ;	              
				                  tdomanda.gric,            ;
				                  tdomanda.modirr,          ;					                  	
				                  ;
				                  space(100) as pse01,   ;
				                  space(100) as pse02,   ;
				                  space(100) as pse03,   ;
				                  space(100) as pse04,   ;
				                  space(100) as pse05,   ;
				                  space(100) as pse06,   ;
				                  space(100) as pse07,   ;
				                  space(100) as pse08,   ;  
				                  space(100) as pse09,   ;  
				                  space(100) as pse10,   ;  
				                  ;
				                  space(230)   as cand01,   ;	                                                         
				                  space(230)   as cand02,   ;	                                                         
				                  space(230)   as cand03,   ;	                                                         
				                  space(230)   as cand04,   ;	                                                         
				                  space(230)   as cand05,   ;	                                                         
				                  space(230)   as cand06,   ;	                                                         
				                  space(230)   as cand07,   ;	                                                         
				                  space(230)   as cand08,   ;	                                                         
				                  space(230)   as cand09,   ;	                                                         
				                  space(230)   as cand10,   ;	                                                         
				                  space(230)   as cand11,   ;	                                                         
				                  space(230)   as cand12,   ;	                                                         
				                  space(230)   as cand13,   ;	                                                         
				                  space(230)   as cand14,   ;	                                                         
				                  space(230)   as cand15,   ;	                                                         
				                  space(230)   as cand16,   ;	                                                         
				                  space(230)   as cand17,    ;	                                                         
				                  space(230)   as cand18,   ;	                                                         
				                  space(230)   as cand19,   ;	                                                         
				                  space(230)   as cand20,   ;	                                                         
				                  space(230)   as cand21,   ;	                                                         
				                  space(230)   as cand22,   ;	                                                         
				                  space(230)   as cand23,   ;	                                                         
				                  space(230)   as cand24,   ;	                                                         
				                  space(230)   as cand25,   ;	                                                         
				                  space(230)   as cand26,   ;	                                                         
				                  space(230)   as cand27,   ;	                                                         
				                  space(230)   as cand28,   ;	                                                         
				                  space(230)   as cand29,   ;	                                                         
				                  space(230)   as cand30    ;	                                                         
					         from tdomanda ;
					        where ( not deleted("tdomanda") )              ;
					          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
					          and tdomanda.gric     =  1                   ;
					          and upper(alltrim(tdomanda.qualifica))==upper(alltrim(m.pca_qualifica)) ;
					        order by tdomanda.cognome asc,                 ;
					                 tdomanda.nome    asc                  ; 
					        into table (m.PathFolderCache+"XDLista.dbf") 

                      otherwise
					       select tdomanda.matricola,       ;
					              tdomanda.cognome,         ;
					              tdomanda.nome,            ;
					              tdomanda.sesso,           ;
					              tdomanda.dnascita,        ;
					              tdomanda.qualifica,       ;
					              tdomanda.ppdesc,          ;
					              tdomanda.ppcode,          ;
					              space(080) as td_pfdesc,  ;
					              space(080) as sede_att,   ;
					              tdomanda.pm_dsz1,         ;		
					              tdomanda.pm_dsz2,         ;
					              tdomanda.pm_code1,        ;
					              tdomanda.pm_code2,        ; 				              						              		
					              tdomanda.ntp_rif,         ;		                            
					              tdomanda.sedea_dal,       ;
					              tdomanda.sedea_dsc,       ;
					              tdomanda.em,              ;
					              tdomanda.protocollo,      ;
					              tdomanda.enote,           ;
					              tdomanda.wnote,           ;
					              space(200) as td_lingue,  ;
					              space(200) as td_curr,    ;
					              space(200) as td_corsi,   ;
					              space(254) as pas,        ;
					              0000       as ngrad,      ;
					              tdomanda.lingua01,        ;
					              tdomanda.lingua02,        ;
					              tdomanda.lingua03,        ;
					              tdomanda.lingua04,        ;
					              tdomanda.lingua05,        ;
					              tdomanda.lingua06,        ;
					              tdomanda.livello01,       ;
					              tdomanda.livello02,       ;
					              tdomanda.livello03,       ;
					              tdomanda.livello04,       ;
					              tdomanda.livello05,       ;
					              tdomanda.livello06,       ;
					              tdomanda.corso01,         ;
					              tdomanda.corso02,         ;
					              tdomanda.corso03,         ;
					              tdomanda.corso04,         ;
					              tdomanda.corso05,         ;
					              tdomanda.corso06,         ;
					              tdomanda.corso07,         ;
					              tdomanda.corso08,         ;
					              tdomanda.corso09,         ;
					              tdomanda.corso10,         ;
					              tdomanda.corso11,         ;
					              tdomanda.corso12,         ;
				                  tdomanda.curr01,          ;	              
				                  tdomanda.curr02,          ;	              
				                  tdomanda.curr03,          ;	              
				                  tdomanda.curr04,          ;	              
				                  tdomanda.curr05,          ;	              
				                  tdomanda.curr06,          ;	              
				                  tdomanda.curr07,          ;	              
				                  tdomanda.curr08,          ;	              
				                  tdomanda.curr09,          ;	              
				                  tdomanda.curr10,          ;	              
				                  tdomanda.curr11,          ;	              
				                  tdomanda.curr12,          ;	              
				                  tdomanda.curr13,          ;	              
				                  tdomanda.curr14,          ;	
				                  tdomanda.curr15,          ;
				                  tdomanda.curr16,          ;	
				                  tdomanda.curr17,          ;	              
				                  tdomanda.nslng01,         ;	              
				                  tdomanda.nslng02,         ;	              
				                  tdomanda.nslng03,         ;	              
				                  tdomanda.nslng04,         ;	              
				                  tdomanda.nslng05,         ;	                                                                                      
				                  tdomanda.bollettino,      ;	              
				                  tdomanda.druolimae,       ;	              
				                  tdomanda.decarriera,      ;	              
				                  tdomanda.deprofilo,       ;	 
				                  tdomanda.dapregctr,       ;	
				                  tdomanda.dapregcom,       ;	
				                  tdomanda.dammprov,        ;	
				                  tdomanda.dcessmae,        ;	
				                  tdomanda.dataestero,      ;	
				                  tdomanda.ggfr,            ;	  
				                  tdomanda.drcomfr,         ;	  
				                  tdomanda.tggmae,          ;	                          
				                  tdomanda.chb,             ;	              
				                  tdomanda.cha,             ;	              
				                  tdomanda.cric,            ;	              
				                  tdomanda.turn,            ;	              
				                  tdomanda.eu5a,            ;	
				                  tdomanda.psb,             ;	
				                  tdomanda.gg15com,         ;	              
				                  tdomanda.ggpt,            ;	              
				                  tdomanda.ggas,            ;	              
				                  tdomanda.ggasp,           ;	              
				                  tdomanda.gric,            ;	
				                  tdomanda.modirr,          ;	
				                  ;
				                  space(100) as pse01,   ;
				                  space(100) as pse02,   ;
				                  space(100) as pse03,   ;
				                  space(100) as pse04,   ;
				                  space(100) as pse05,   ;
				                  space(100) as pse06,   ;
				                  space(100) as pse07,   ;
				                  space(100) as pse08,   ;  
				                  space(100) as pse09,   ;  
				                  space(100) as pse10,   ;  
				                  ;
				                  space(230)   as cand01,   ;	                                                         
				                  space(230)   as cand02,   ;	                                                         
				                  space(230)   as cand03,   ;	                                                         
				                  space(230)   as cand04,   ;	                                                         
				                  space(230)   as cand05,   ;	                                                         
				                  space(230)   as cand06,   ;	                                                         
				                  space(230)   as cand07,   ;	                                                         
				                  space(230)   as cand08,   ;	                                                         
				                  space(230)   as cand09,   ;	                                                         
				                  space(230)   as cand10,   ;	                                                         
				                  space(230)   as cand11,   ;	                                                         
				                  space(230)   as cand12,   ;	                                                         
				                  space(230)   as cand13,   ;	                                                         
				                  space(230)   as cand14,   ;	                                                         
				                  space(230)   as cand15,   ;	                                                         
				                  space(230)   as cand16,   ;	                                                         
				                  space(230)   as cand17,    ;	                                                         
				                  space(230)   as cand18,   ;	                                                         
				                  space(230)   as cand19,   ;	                                                         
				                  space(230)   as cand20,   ;	                                                         
				                  space(230)   as cand21,   ;	                                                         
				                  space(230)   as cand22,   ;	                                                         
				                  space(230)   as cand23,   ;	                                                         
				                  space(230)   as cand24,   ;	                                                         
				                  space(230)   as cand25,   ;	                                                         
				                  space(230)   as cand26,   ;	                                                         
				                  space(230)   as cand27,   ;	                                                         
				                  space(230)   as cand28,   ;	                                                         
				                  space(230)   as cand29,   ;	                                                         
				                  space(230)   as cand30    ;	                                                         
					         from tdomanda ;
					        where ( not deleted("tdomanda") )              ;
					          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
					          and upper(alltrim(tdomanda.qualifica))==upper(alltrim(m.pca_qualifica)) ;
					        order by tdomanda.cognome asc,                 ;
					                 tdomanda.nome    asc                  ; 
					        into table (m.PathFolderCache+"XDLista.dbf") 
                   endcase

           *- Elenco Anagrafico Domande per Profilo di Appartenenza e Maturato     
              case thisform.passListType.Value = 3
                   do case
                   *- Senza gli Irricevibili
                      case thisform.wirric.Value = 1
					       select tdomanda.matricola,       ;
					              tdomanda.cognome,         ;
					              tdomanda.nome,            ;
					              tdomanda.sesso,           ;
					              tdomanda.dnascita,        ;
					              tdomanda.qualifica,       ;
					              tdomanda.ppdesc,          ;
					              tdomanda.ppcode,          ;
					              space(080) as td_pfdesc,  ;
					              space(080) as sede_att,   ;
					              tdomanda.pm_dsz1,         ;		
					              tdomanda.pm_dsz2,         ;	
					              tdomanda.pm_code1,        ;
					              tdomanda.pm_code2,        ; 	
					              tdomanda.ntp_rif,         ;		                            
					              tdomanda.sedea_dal,       ;
					              tdomanda.sedea_dsc,       ;
					              tdomanda.em,              ;
					              tdomanda.protocollo,      ;
					              tdomanda.enote,           ;
					              tdomanda.wnote,           ;
					              space(200) as td_lingue,  ;
					              space(200) as td_curr,    ;
					              space(200) as td_corsi,   ;
					              space(254) as pas,        ;
					              0000       as ngrad,      ;
					              tdomanda.lingua01,        ;
					              tdomanda.lingua02,        ;
					              tdomanda.lingua03,        ;
					              tdomanda.lingua04,        ;
					              tdomanda.lingua05,        ;
					              tdomanda.lingua06,        ;
					              tdomanda.livello01,       ;
					              tdomanda.livello02,       ;
					              tdomanda.livello03,       ;
					              tdomanda.livello04,       ;
					              tdomanda.livello05,       ;
					              tdomanda.livello06,       ;
					              tdomanda.corso01,         ;
					              tdomanda.corso02,         ;
					              tdomanda.corso03,         ;
					              tdomanda.corso04,         ;
					              tdomanda.corso05,         ;
					              tdomanda.corso06,         ;
					              tdomanda.corso07,         ;
					              tdomanda.corso08,         ;
					              tdomanda.corso09,         ;
					              tdomanda.corso10,         ;
					              tdomanda.corso11,         ;
					              tdomanda.corso12,         ;
				                  tdomanda.curr01,          ;	              
				                  tdomanda.curr02,          ;	              
				                  tdomanda.curr03,          ;	              
				                  tdomanda.curr04,          ;	              
				                  tdomanda.curr05,          ;	              
				                  tdomanda.curr06,          ;	              
				                  tdomanda.curr07,          ;	              
				                  tdomanda.curr08,          ;	              
				                  tdomanda.curr09,          ;	              
				                  tdomanda.curr10,          ;	              
				                  tdomanda.curr11,          ;	              
				                  tdomanda.curr12,          ;	              
				                  tdomanda.curr13,          ;	              
				                  tdomanda.curr14,          ;	
				                  tdomanda.curr15,          ;
				                  tdomanda.curr16,          ;	
				                  tdomanda.curr17,          ;	              
				                  tdomanda.nslng01,         ;	              
				                  tdomanda.nslng02,         ;	              
				                  tdomanda.nslng03,         ;	              
				                  tdomanda.nslng04,         ;	              
				                  tdomanda.nslng05,         ;	                                                                                      
				                  tdomanda.bollettino,      ;	              
				                  tdomanda.druolimae,       ;	              
				                  tdomanda.decarriera,      ;	              
				                  tdomanda.deprofilo,       ;	 
				                  tdomanda.dapregctr,       ;	
				                  tdomanda.dapregcom,       ;	
				                  tdomanda.dammprov,        ;	
				                  tdomanda.dcessmae,        ;	
				                  tdomanda.dataestero,      ;	
				                  tdomanda.ggfr,            ;	  
				                  tdomanda.drcomfr,         ;	  
				                  tdomanda.tggmae,          ;	                          
				                  tdomanda.chb,             ;	              
				                  tdomanda.cha,             ;	              
				                  tdomanda.cric,            ;	              
				                  tdomanda.turn,            ;	              
				                  tdomanda.eu5a,            ;	
				                  tdomanda.psb,             ;	
				                  tdomanda.gg15com,         ;	              
				                  tdomanda.ggpt,            ;	              
				                  tdomanda.ggas,            ;	              
				                  tdomanda.ggasp,           ;	              
				                  tdomanda.gric,            ;	
				                  tdomanda.modirr,          ;					                  
				                  ;
				                  space(100) as pse01,   ;
				                  space(100) as pse02,   ;
				                  space(100) as pse03,   ;
				                  space(100) as pse04,   ;
				                  space(100) as pse05,   ;
				                  space(100) as pse06,   ;
				                  space(100) as pse07,   ;
				                  space(100) as pse08,   ;  
				                  space(100) as pse09,   ;  
				                  space(100) as pse10,   ;  
				                  ;
				                  space(230)   as cand01,   ;	                                                         
				                  space(230)   as cand02,   ;	                                                         
				                  space(230)   as cand03,   ;	                                                         
				                  space(230)   as cand04,   ;	                                                         
				                  space(230)   as cand05,   ;	                                                         
				                  space(230)   as cand06,   ;	                                                         
				                  space(230)   as cand07,   ;	                                                         
				                  space(230)   as cand08,   ;	                                                         
				                  space(230)   as cand09,   ;	                                                         
				                  space(230)   as cand10,   ;	                                                         
				                  space(230)   as cand11,   ;	                                                         
				                  space(230)   as cand12,   ;	                                                         
				                  space(230)   as cand13,   ;	                                                         
				                  space(230)   as cand14,   ;	                                                         
				                  space(230)   as cand15,   ;	                                                         
				                  space(230)   as cand16,   ;	                                                         
				                  space(230)   as cand17,    ;	                                                         
				                  space(230)   as cand18,   ;	                                                         
				                  space(230)   as cand19,   ;	                                                         
				                  space(230)   as cand20,   ;	                                                         
				                  space(230)   as cand21,   ;	                                                         
				                  space(230)   as cand22,   ;	                                                         
				                  space(230)   as cand23,   ;	                                                         
				                  space(230)   as cand24,   ;	                                                         
				                  space(230)   as cand25,   ;	                                                         
				                  space(230)   as cand26,   ;	                                                         
				                  space(230)   as cand27,   ;	                                                         
				                  space(230)   as cand28,   ;	                                                         
				                  space(230)   as cand29,   ;	                                                         
				                  space(230)   as cand30    ;	                                                         
					         from tdomanda ;
					        where ( not deleted("tdomanda") )              ;
					          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
					          and ( tdomanda.ppcode = m.pca_ppcode or tdomanda.pm_code1 = m.pca_ppcode or tdomanda.pm_code2 = m.pca_ppcode ) ;
					          and tdomanda.gric     =  1                   ;
					        order by tdomanda.cognome asc,                 ;
					                 tdomanda.nome    asc                  ; 
					        into table (m.PathFolderCache+"XDLista.dbf") 

                      otherwise
					       select tdomanda.matricola,       ;
					              tdomanda.cognome,         ;
					              tdomanda.nome,            ;
					              tdomanda.sesso,           ;
					              tdomanda.dnascita,        ;
					              tdomanda.qualifica,       ;
					              tdomanda.ppdesc,          ;
					              tdomanda.ppcode,          ;
					              space(080) as td_pfdesc,  ;
					              space(080) as sede_att,   ;
					              tdomanda.pm_dsz1,         ;		
					              tdomanda.pm_dsz2,         ;
					              tdomanda.pm_code1,        ;
					              tdomanda.pm_code2,        ; 						              		
					              tdomanda.ntp_rif,         ;		                            
					              tdomanda.sedea_dal,       ;
					              tdomanda.sedea_dsc,       ;
					              tdomanda.em,              ;
					              tdomanda.protocollo,      ;
					              tdomanda.enote,           ;
					              tdomanda.wnote,           ;
					              space(200) as td_lingue,  ;
					              space(200) as td_curr,    ;
					              space(200) as td_corsi,   ;
					              space(254) as pas,        ;
					              0000       as ngrad,      ;
					              tdomanda.lingua01,        ;
					              tdomanda.lingua02,        ;
					              tdomanda.lingua03,        ;
					              tdomanda.lingua04,        ;
					              tdomanda.lingua05,        ;
					              tdomanda.lingua06,        ;
					              tdomanda.livello01,       ;
					              tdomanda.livello02,       ;
					              tdomanda.livello03,       ;
					              tdomanda.livello04,       ;
					              tdomanda.livello05,       ;
					              tdomanda.livello06,       ;
					              tdomanda.corso01,         ;
					              tdomanda.corso02,         ;
					              tdomanda.corso03,         ;
					              tdomanda.corso04,         ;
					              tdomanda.corso05,         ;
					              tdomanda.corso06,         ;
					              tdomanda.corso07,         ;
					              tdomanda.corso08,         ;
					              tdomanda.corso09,         ;
					              tdomanda.corso10,         ;
					              tdomanda.corso11,         ;
					              tdomanda.corso12,         ;
				                  tdomanda.curr01,          ;	              
				                  tdomanda.curr02,          ;	              
				                  tdomanda.curr03,          ;	              
				                  tdomanda.curr04,          ;	              
				                  tdomanda.curr05,          ;	              
				                  tdomanda.curr06,          ;	              
				                  tdomanda.curr07,          ;	              
				                  tdomanda.curr08,          ;	              
				                  tdomanda.curr09,          ;	              
				                  tdomanda.curr10,          ;	              
				                  tdomanda.curr11,          ;	              
				                  tdomanda.curr12,          ;	              
				                  tdomanda.curr13,          ;	              
				                  tdomanda.curr14,          ;	
				                  tdomanda.curr15,          ;
				                  tdomanda.curr16,          ;	
				                  tdomanda.curr17,          ;	              
				                  tdomanda.nslng01,         ;	              
				                  tdomanda.nslng02,         ;	              
				                  tdomanda.nslng03,         ;	              
				                  tdomanda.nslng04,         ;	              
				                  tdomanda.nslng05,         ;	                                                                                      
				                  tdomanda.bollettino,      ;	              
				                  tdomanda.druolimae,       ;	              
				                  tdomanda.decarriera,      ;	              
				                  tdomanda.deprofilo,       ;	 
				                  tdomanda.dapregctr,       ;	
				                  tdomanda.dapregcom,       ;	
				                  tdomanda.dammprov,        ;	
				                  tdomanda.dcessmae,        ;	
				                  tdomanda.dataestero,      ;	
				                  tdomanda.ggfr,            ;	  
				                  tdomanda.drcomfr,         ;	  
				                  tdomanda.tggmae,          ;	                          
				                  tdomanda.chb,             ;	              
				                  tdomanda.cha,             ;	              
				                  tdomanda.cric,            ;	              
				                  tdomanda.turn,            ;	              
				                  tdomanda.eu5a,            ;	
				                  tdomanda.psb,             ;	
				                  tdomanda.gg15com,         ;	              
				                  tdomanda.ggpt,            ;	              
				                  tdomanda.ggas,            ;	              
				                  tdomanda.ggasp,           ;	              
				                  tdomanda.gric,            ;
				                  tdomanda.modirr,          ;					                  	
				                  ;
				                  space(100) as pse01,   ;
				                  space(100) as pse02,   ;
				                  space(100) as pse03,   ;
				                  space(100) as pse04,   ;
				                  space(100) as pse05,   ;
				                  space(100) as pse06,   ;
				                  space(100) as pse07,   ;
				                  space(100) as pse08,   ;  
				                  space(100) as pse09,   ;  
				                  space(100) as pse10,   ;  
				                  ;
				                  space(230)   as cand01,   ;	                                                         
				                  space(230)   as cand02,   ;	                                                         
				                  space(230)   as cand03,   ;	                                                         
				                  space(230)   as cand04,   ;	                                                         
				                  space(230)   as cand05,   ;	                                                         
				                  space(230)   as cand06,   ;	                                                         
				                  space(230)   as cand07,   ;	                                                         
				                  space(230)   as cand08,   ;	                                                         
				                  space(230)   as cand09,   ;	                                                         
				                  space(230)   as cand10,   ;	                                                         
				                  space(230)   as cand11,   ;	                                                         
				                  space(230)   as cand12,   ;	                                                         
				                  space(230)   as cand13,   ;	                                                         
				                  space(230)   as cand14,   ;	                                                         
				                  space(230)   as cand15,   ;	                                                         
				                  space(230)   as cand16,   ;	                                                         
				                  space(230)   as cand17,    ;	                                                         
				                  space(230)   as cand18,   ;	                                                         
				                  space(230)   as cand19,   ;	                                                         
				                  space(230)   as cand20,   ;	                                                         
				                  space(230)   as cand21,   ;	                                                         
				                  space(230)   as cand22,   ;	                                                         
				                  space(230)   as cand23,   ;	                                                         
				                  space(230)   as cand24,   ;	                                                         
				                  space(230)   as cand25,   ;	                                                         
				                  space(230)   as cand26,   ;	                                                         
				                  space(230)   as cand27,   ;	                                                         
				                  space(230)   as cand28,   ;	                                                         
				                  space(230)   as cand29,   ;	                                                         
				                  space(230)   as cand30    ;	                                                         
					         from tdomanda ;
					        where ( not deleted("tdomanda") )              ;
					          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
					          and ( tdomanda.ppcode = m.pca_ppcode or tdomanda.pm_code1 = m.pca_ppcode or tdomanda.pm_code2 = m.pca_ppcode ) ;
					        order by tdomanda.cognome asc,                 ;
					                 tdomanda.nome    asc                  ; 
					        into table (m.PathFolderCache+"XDLista.dbf") 
                   endcase

              case thisform.passListType.Value = 4
			       select tdomanda.matricola,       ;
			              tdomanda.cognome,         ;
			              tdomanda.nome,            ;
			              tdomanda.sesso,           ;
			              tdomanda.dnascita,        ;
			              tdomanda.qualifica,       ;
			              tdomanda.ppdesc,          ;
			              tdomanda.ppcode,          ;
			              space(080) as td_pfdesc,  ;
			              space(080) as sede_att,   ;
			              tdomanda.pm_dsz1,         ;		
			              tdomanda.pm_dsz2,         ;	
			              tdomanda.pm_code1,        ;
			              tdomanda.pm_code2,        ; 
			              tdomanda.pm_code1,        ;
			              tdomanda.pm_code2,        ; 				              				              				              	
			              tdomanda.ntp_rif,         ;		                            
			              tdomanda.sedea_dal,       ;
			              tdomanda.sedea_dsc,       ;
			              tdomanda.em,              ;
			              tdomanda.protocollo,      ;
			              tdomanda.enote,           ;
			              tdomanda.wnote,           ;
			              space(200) as td_lingue,  ;
			              space(200) as td_curr,    ;
			              space(200) as td_corsi,   ;
			              space(254) as pas,        ;
			              0000       as ngrad,      ;
			              tdomanda.lingua01,        ;
			              tdomanda.lingua02,        ;
			              tdomanda.lingua03,        ;
			              tdomanda.lingua04,        ;
			              tdomanda.lingua05,        ;
			              tdomanda.lingua06,        ;
			              tdomanda.livello01,       ;
			              tdomanda.livello02,       ;
			              tdomanda.livello03,       ;
			              tdomanda.livello04,       ;
			              tdomanda.livello05,       ;
			              tdomanda.livello06,       ;
			              tdomanda.corso01,         ;
			              tdomanda.corso02,         ;
			              tdomanda.corso03,         ;
			              tdomanda.corso04,         ;
			              tdomanda.corso05,         ;
			              tdomanda.corso06,         ;
			              tdomanda.corso07,         ;
			              tdomanda.corso08,         ;
			              tdomanda.corso09,         ;
			              tdomanda.corso10,         ;
			              tdomanda.corso11,         ;
			              tdomanda.corso12,         ;
		                  tdomanda.curr01,          ;	              
		                  tdomanda.curr02,          ;	              
		                  tdomanda.curr03,          ;	              
		                  tdomanda.curr04,          ;	              
		                  tdomanda.curr05,          ;	              
		                  tdomanda.curr06,          ;	              
		                  tdomanda.curr07,          ;	              
		                  tdomanda.curr08,          ;	              
		                  tdomanda.curr09,          ;	              
		                  tdomanda.curr10,          ;	              
		                  tdomanda.curr11,          ;	              
		                  tdomanda.curr12,          ;	              
		                  tdomanda.curr13,          ;	              
		                  tdomanda.curr14,          ;	
		                  tdomanda.curr15,          ;
		                  tdomanda.curr16,          ;
		                  tdomanda.curr17,          ;	              
		                  tdomanda.nslng01,         ;	              
		                  tdomanda.nslng02,         ;	              
		                  tdomanda.nslng03,         ;	              
		                  tdomanda.nslng04,         ;	              
		                  tdomanda.nslng05,         ;	                                                                                      
		                  tdomanda.bollettino,      ;	              
		                  tdomanda.druolimae,       ;	              
		                  tdomanda.decarriera,      ;	              
		                  tdomanda.deprofilo,       ;	 
		                  tdomanda.dapregctr,       ;	
		                  tdomanda.dapregcom,       ;	
		                  tdomanda.dammprov,        ;	
		                  tdomanda.dcessmae,        ;	
		                  tdomanda.dataestero,      ;	
		                  tdomanda.ggfr,            ;	  
		                  tdomanda.drcomfr,         ;	  
		                  tdomanda.tggmae,          ;	                          
		                  tdomanda.chb,             ;	              
		                  tdomanda.cha,             ;	              
		                  tdomanda.cric,            ;	              
		                  tdomanda.turn,            ;	              
		                  tdomanda.eu5a,            ;	
		                  tdomanda.psb,             ;	
		                  tdomanda.gg15com,         ;	              
		                  tdomanda.ggpt,            ;	              
		                  tdomanda.ggas,            ;	              
		                  tdomanda.ggasp,           ;	              
		                  tdomanda.gric,            ;	
				          tdomanda.modirr,          ;			                  
		                  ;
		                  space(100) as pse01,   ;
		                  space(100) as pse02,   ;
		                  space(100) as pse03,   ;
		                  space(100) as pse04,   ;
		                  space(100) as pse05,   ;
		                  space(100) as pse06,   ;
		                  space(100) as pse07,   ;
		                  space(100) as pse08,   ;  
		                  space(100) as pse09,   ;  
		                  space(100) as pse10,   ;  
		                  ;
		                  space(230)   as cand01,   ;	                                                         
		                  space(230)   as cand02,   ;	                                                         
		                  space(230)   as cand03,   ;	                                                         
		                  space(230)   as cand04,   ;	                                                         
		                  space(230)   as cand05,   ;	                                                         
		                  space(230)   as cand06,   ;	                                                         
		                  space(230)   as cand07,   ;	                                                         
		                  space(230)   as cand08,   ;	                                                         
		                  space(230)   as cand09,   ;	                                                         
		                  space(230)   as cand10,   ;	                                                         
		                  space(230)   as cand11,   ;	                                                         
		                  space(230)   as cand12,   ;	                                                         
		                  space(230)   as cand13,   ;	                                                         
		                  space(230)   as cand14,   ;	                                                         
		                  space(230)   as cand15,   ;	                                                         
		                  space(230)   as cand16,   ;	                                                         
		                  space(230)   as cand17,    ;	                                                         
		                  space(230)   as cand18,   ;	                                                         
		                  space(230)   as cand19,   ;	                                                         
		                  space(230)   as cand20,   ;	                                                         
		                  space(230)   as cand21,   ;	                                                         
		                  space(230)   as cand22,   ;	                                                         
		                  space(230)   as cand23,   ;	                                                         
		                  space(230)   as cand24,   ;	                                                         
		                  space(230)   as cand25,   ;	                                                         
		                  space(230)   as cand26,   ;	                                                         
		                  space(230)   as cand27,   ;	                                                         
		                  space(230)   as cand28,   ;	                                                         
		                  space(230)   as cand29,   ;	                                                         
		                  space(230)   as cand30    ;	                                                         
			         from tdomanda ;
			        where ( not deleted("tdomanda") )              ;
			          and tdomanda.pbls_rif =  m.pca_pbls_rif      ;
			          and tdomanda.gric     = 0                    ;
			        order by tdomanda.cognome asc,                 ;
			                 tdomanda.nome    asc                  ; 
			        into table (m.PathFolderCache+"XDLista.dbf") 
              otherwise
                   return
           endcase

	       select tdposto.pbls_rif,         ;
	              tdposto.protocollo,       ;
	              tdposto.pref,             ;        
	              tdposto.nsedia,           ;
	              tdposto.pjob,             ;
	              tdposto.prel,             ;
	              tdposto.plingua,          ;
	              tdposto.sricev,           ;
	              tdposto.escludi,          ;
	              space(010) as shortrango, ;
	              space(100) as sede,       ;
	              space(005) as disagio,    ;
	              0          as bellica,    ;     
	              0          as diffcop     ;     
	         from tdposto                   ;
	        where ( not deleted("tdposto") )         ;
	          and tdposto.pbls_rif =  m.pca_pbls_rif ;
	        into table (m.PathFolderCache+"XDPosto.dbf") 

	       select oestorico.matricola,     ;
	              oestorico.dataasspos,    ;        
	              oestorico.datacesspo,    ;        
	              oestorico.annota         ;
	         from oestorico                ;
	        where ( not deleted("oestorico") )   ;
	          and oestorico.matricola in         ;
	              ( select distinct XDLista.matricola from XDLista ) ;
	        into table (m.PathFolderCache+"XStorico.dbf") 

	   
	   *-- Enrich Posto
	       select XDPosto
	       go top
	       scan
	       
	          m.zxKey = alltrim(str(XDPosto.pbls_rif))+alltrim(str(XDPosto.nsedia))
	          if seek(m.zxKey,"trlist","listsedia") then
	             select XDPosto
	             replace XDPosto.shortrango   with GetDesShortRango(trlist.rango)
	             replace XDPosto.sede         with trlist.sede
	             replace XDPosto.disagio      with trlist.disagio
	             replace XDPosto.bellica      with trlist.bellica
	             replace XDPosto.diffcop      with trlist.diffcop	             
	          endif 
	          select XDPosto
	          
	       endscan     
	        
	   *-- Generazione Graduatoria
	       =GetClassification(m.pca_pbls_rif) 

	        
       *-- Enrich Base Entity
*!*	           select XDLista
*!*	           replace all XDLista.cand01 with space(200)  
           m.jk_sede = ""
           select xdposto
           go top           
           scan  
                  
                   m.jk_sede = alltrim(xdposto.sede)
                   
*!*	                   +"   ("+alltrim(xdposto.disagio)
*!*	                   if xdposto.diffcop = 1 then
*!*	                      m.jk_sede = m.jk_sede+","+"DC"
*!*	                   endif
*!*	                   
*!*	                   if xdposto.bellica = 1 then
*!*	                      m.jk_sede = m.jk_sede+","+"B"
*!*	                   endif
*!*	                    m.jk_sede = m.jk_sede+")"
                    
                  
                  select glist
                  locate for glist.protocollo =  xdposto.protocollo ;
                         and glist.nsedia     =  xdposto.nsedia
                  if found("glist") then
                     m.xPosGrad = glist.ngrad
                  else   
                     m.xPosGrad = 0
                  endif              

                   
	              select XDLista
	              locate for XDLista.protocollo = XDPosto.protocollo	              
	              if found("XDLista") then	                 
	                 do case
	                    case xdposto.pref = 1	                         
	                         select XDLista	                         
	                         replace XDLista.cand01 with stuff(XDLista.cand01, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1) )
	                         replace XDLista.cand01 with stuff(XDLista.cand01, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand01 with stuff(XDLista.cand01, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand01 with stuff(XDLista.cand01, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand01 with stuff(XDLista.cand01, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand01 with stuff(XDLista.cand01, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )

	                    case xdposto.pref = 2	                         
	                         select XDLista	                         
	                         replace XDLista.cand02 with stuff(XDLista.cand02, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand02 with stuff(XDLista.cand02, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand02 with stuff(XDLista.cand02, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand02 with stuff(XDLista.cand02, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand02 with stuff(XDLista.cand02, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand02 with stuff(XDLista.cand02, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )

	                    case xdposto.pref = 3	                         
	                         select XDLista	                         
	                         replace XDLista.cand03 with stuff(XDLista.cand03, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand03 with stuff(XDLista.cand03, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand03 with stuff(XDLista.cand03, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand03 with stuff(XDLista.cand03, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand03 with stuff(XDLista.cand03, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand03 with stuff(XDLista.cand03, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 4	                         
	                         select XDLista	                         
	                         replace XDLista.cand04 with stuff(XDLista.cand04, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand04 with stuff(XDLista.cand04, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand04 with stuff(XDLista.cand04, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand04 with stuff(XDLista.cand04, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand04 with stuff(XDLista.cand04, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand04 with stuff(XDLista.cand04, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 5	                         
	                         select XDLista	                         
	                         replace XDLista.cand05 with stuff(XDLista.cand05, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand05 with stuff(XDLista.cand05, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand05 with stuff(XDLista.cand05, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand05 with stuff(XDLista.cand05, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand05 with stuff(XDLista.cand05, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand05 with stuff(XDLista.cand05, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )

	                         
	                    case xdposto.pref = 6	                         
	                         select XDLista	                         
	                         replace XDLista.cand06 with stuff(XDLista.cand06, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand06 with stuff(XDLista.cand06, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand06 with stuff(XDLista.cand06, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand06 with stuff(XDLista.cand06, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand06 with stuff(XDLista.cand06, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand06 with stuff(XDLista.cand06, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 7	                         
	                         select XDLista	                         
	                         replace XDLista.cand07 with stuff(XDLista.cand07, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand07 with stuff(XDLista.cand07, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand07 with stuff(XDLista.cand07, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand07 with stuff(XDLista.cand07, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand07 with stuff(XDLista.cand07, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand07 with stuff(XDLista.cand07, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 8	                         
	                         select XDLista	                         
	                         replace XDLista.cand08 with stuff(XDLista.cand08, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand08 with stuff(XDLista.cand08, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand08 with stuff(XDLista.cand08, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand08 with stuff(XDLista.cand08, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand08 with stuff(XDLista.cand08, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand08 with stuff(XDLista.cand08, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 9	                         
	                         select XDLista	                         
	                         replace XDLista.cand09 with stuff(XDLista.cand09, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand09 with stuff(XDLista.cand09, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand09 with stuff(XDLista.cand09, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand09 with stuff(XDLista.cand09, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand09 with stuff(XDLista.cand09, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand09 with stuff(XDLista.cand09, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 10	                         
	                         select XDLista	                         
	                         replace XDLista.cand10 with stuff(XDLista.cand10, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand10 with stuff(XDLista.cand10, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand10 with stuff(XDLista.cand10, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand10 with stuff(XDLista.cand10, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand10 with stuff(XDLista.cand10, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand10 with stuff(XDLista.cand10, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 11	                         
	                         select XDLista	                         
	                         replace XDLista.cand11 with stuff(XDLista.cand11, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand11 with stuff(XDLista.cand11, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand11 with stuff(XDLista.cand11, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand11 with stuff(XDLista.cand11, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand11 with stuff(XDLista.cand11, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand11 with stuff(XDLista.cand11, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 12	                         
	                         select XDLista	                         
	                         replace XDLista.cand12 with stuff(XDLista.cand12, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand12 with stuff(XDLista.cand12, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand12 with stuff(XDLista.cand12, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand12 with stuff(XDLista.cand12, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand12 with stuff(XDLista.cand12, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand12 with stuff(XDLista.cand12, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 13	                         
	                         select XDLista	                         
	                         replace XDLista.cand13 with stuff(XDLista.cand13, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand13 with stuff(XDLista.cand13, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand13 with stuff(XDLista.cand13, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand13 with stuff(XDLista.cand13, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand13 with stuff(XDLista.cand13, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand13 with stuff(XDLista.cand13, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 14	                         
	                         select XDLista	                         
	                         replace XDLista.cand14 with stuff(XDLista.cand14, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand14 with stuff(XDLista.cand14, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand14 with stuff(XDLista.cand14, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand14 with stuff(XDLista.cand14, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand14 with stuff(XDLista.cand14, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand14 with stuff(XDLista.cand14, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 15	                         
	                         select XDLista	                         
	                         replace XDLista.cand15 with stuff(XDLista.cand15, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand15 with stuff(XDLista.cand15, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand15 with stuff(XDLista.cand15, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand15 with stuff(XDLista.cand15, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand15 with stuff(XDLista.cand15, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand15 with stuff(XDLista.cand15, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )



	                    case xdposto.pref = 16	                         
	                         select XDLista	                         
	                         replace XDLista.cand16 with stuff(XDLista.cand16, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand16 with stuff(XDLista.cand16, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand16 with stuff(XDLista.cand16, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand16 with stuff(XDLista.cand16, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand16 with stuff(XDLista.cand16, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand16 with stuff(XDLista.cand16, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 17	                         
	                         select XDLista	                         
	                         replace XDLista.cand17 with stuff(XDLista.cand17, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand17 with stuff(XDLista.cand17, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand17 with stuff(XDLista.cand17, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand17 with stuff(XDLista.cand17, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand17 with stuff(XDLista.cand17, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand17 with stuff(XDLista.cand17, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )

	                         
	                    case xdposto.pref = 18	                         
	                         select XDLista	                         
	                         replace XDLista.cand18 with stuff(XDLista.cand18, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand18 with stuff(XDLista.cand18, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand18 with stuff(XDLista.cand18, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand18 with stuff(XDLista.cand18, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand18 with stuff(XDLista.cand18, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand18 with stuff(XDLista.cand18, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 19	                         
	                         select XDLista	                         
	                         replace XDLista.cand19 with stuff(XDLista.cand19, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand19 with stuff(XDLista.cand19, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand19 with stuff(XDLista.cand19, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand19 with stuff(XDLista.cand19, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand19 with stuff(XDLista.cand19, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand19 with stuff(XDLista.cand19, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 20	                         
	                         select XDLista	                         
	                         replace XDLista.cand20 with stuff(XDLista.cand20, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand20 with stuff(XDLista.cand20, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand20 with stuff(XDLista.cand20, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand20 with stuff(XDLista.cand20, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand20 with stuff(XDLista.cand20, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand20 with stuff(XDLista.cand20, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 21	                         
	                         select XDLista	                         
	                         replace XDLista.cand21 with stuff(XDLista.cand21, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand21 with stuff(XDLista.cand21, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand21 with stuff(XDLista.cand21, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand21 with stuff(XDLista.cand21, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand21 with stuff(XDLista.cand21, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand21 with stuff(XDLista.cand21, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 22	                         
	                         select XDLista	                         
	                         replace XDLista.cand22 with stuff(XDLista.cand22, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand22 with stuff(XDLista.cand22, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand22 with stuff(XDLista.cand22, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand22 with stuff(XDLista.cand22, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand22 with stuff(XDLista.cand22, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand22 with stuff(XDLista.cand22, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 23	                         
	                         select XDLista	                         
	                         replace XDLista.cand23 with stuff(XDLista.cand23, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand23 with stuff(XDLista.cand23, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand23 with stuff(XDLista.cand23, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand23 with stuff(XDLista.cand23, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand23 with stuff(XDLista.cand23, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand23 with stuff(XDLista.cand23, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )
	                         


	                    case xdposto.pref = 24	                         
	                         select XDLista	                         
	                         replace XDLista.cand24 with stuff(XDLista.cand24, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand24 with stuff(XDLista.cand24, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand24 with stuff(XDLista.cand24, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand24 with stuff(XDLista.cand24, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand24 with stuff(XDLista.cand24, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand24 with stuff(XDLista.cand24, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 25	                         
	                         select XDLista	                         
	                         replace XDLista.cand25 with stuff(XDLista.cand25, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand25 with stuff(XDLista.cand25, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand25 with stuff(XDLista.cand25, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand25 with stuff(XDLista.cand25, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand25 with stuff(XDLista.cand25, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand25 with stuff(XDLista.cand25, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 26	                         
	                         select XDLista	                         
	                         replace XDLista.cand26 with stuff(XDLista.cand26, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand26 with stuff(XDLista.cand26, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand26 with stuff(XDLista.cand26, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand26 with stuff(XDLista.cand26, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand26 with stuff(XDLista.cand26, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand26 with stuff(XDLista.cand26, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 27	                         
	                         select XDLista	                         
	                         replace XDLista.cand27 with stuff(XDLista.cand27, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand27 with stuff(XDLista.cand27, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand27 with stuff(XDLista.cand27, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand27 with stuff(XDLista.cand27, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand27 with stuff(XDLista.cand27, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand27 with stuff(XDLista.cand27, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 28	                         
	                         select XDLista	                         
	                         replace XDLista.cand28 with stuff(XDLista.cand28, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand28 with stuff(XDLista.cand28, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand28 with stuff(XDLista.cand28, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand28 with stuff(XDLista.cand28, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand28 with stuff(XDLista.cand28, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand28 with stuff(XDLista.cand28, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 29	                         
	                         select XDLista	                         
	                         replace XDLista.cand29 with stuff(XDLista.cand29, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand29 with stuff(XDLista.cand29, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand29 with stuff(XDLista.cand29, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand29 with stuff(XDLista.cand29, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand29 with stuff(XDLista.cand29, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand29 with stuff(XDLista.cand29, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )


	                    case xdposto.pref = 30	                         
	                         select XDLista	                         
	                         replace XDLista.cand30 with stuff(XDLista.cand30, 001, len(alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1)),  alltrim(str(xdposto.pref))+"-"+substr(alltrim(xdposto.prel),1,1))
	                         replace XDLista.cand30 with stuff(XDLista.cand30, 006, len(alltrim(str(xdposto.nsedia))),alltrim(str(xdposto.nsedia)))
	                         replace XDLista.cand30 with stuff(XDLista.cand30, 016, len(alltrim(xdposto.shortrango)), alltrim(xdposto.shortrango))
	                         replace XDLista.cand30 with stuff(XDLista.cand30, 021, len(alltrim(m.jk_sede)),          alltrim(m.jk_sede))
	                         replace XDLista.cand30 with stuff(XDLista.cand30, 100, len(alltrim(str(m.xPosGrad))),    alltrim(str(m.xPosGrad)) )
	                         replace XDLista.cand30 with stuff(XDLista.cand30, 220, len(iif(xdposto.escludi=1,"**","")),iif(xdposto.escludi=1,"**","") )

	                 endcase
	                 
	              endif
	              
	              
                            
              select xdposto
           endscan          
      

    *-- Data Enrichment
        local m.zx_sedeadsc as String
        m.zx_sedeadsc = ""
        select XDLista
        go top
        scan

           *-- Profilo APP Candidato
               select profilo
               locate for profilo.ppcode = XDLista.ppcode
               if found("profilo") then
                  select XDLista
                  replace XDLista.td_pfdesc with profilo.pfdesc
               endif
               
            *-- Lingue Candidato
			    m.ListLingue = ""
				if ( not len(alltrim(XDLista.lingua01)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+ substr(alltrim(XDLista.lingua01),1,3)+"/"+GetShortLevelLanguage(alltrim(XDLista.livello01))+"  "
				endif

				if ( not len(alltrim(XDLista.lingua02)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+  substr(alltrim(XDLista.lingua02),1,3)+"/"+GetShortLevelLanguage(alltrim(XDLista.livello02))+"  "
				endif

				if ( not len(alltrim(XDLista.lingua03)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+  substr(alltrim(XDLista.lingua03),1,3)+"/"+GetShortLevelLanguage(alltrim(XDLista.livello03))+"  "
				endif

				if ( not len(alltrim(XDLista.lingua04)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+  substr(alltrim(XDLista.lingua04),1,3)+"/"+GetShortLevelLanguage(alltrim(XDLista.livello04))+"  "
				endif

				if ( not len(alltrim(XDLista.lingua05)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+  substr(alltrim(XDLista.lingua05),1,3)+"/"+GetShortLevelLanguage(alltrim(XDLista.livello05))+"  "
				endif
				if ( not len(alltrim(XDLista.lingua06)) = 0 ) then
				   m.ListLingue = alltrim(m.ListLingue)+"  "+  substr(alltrim(XDLista.lingua06),1,3)+"/"+GetShortLevelLanguage(alltrim(XDLista.livello06))+"  "
				endif

                select XDLista
                replace XDLista.td_lingue with m.ListLingue

            *-- Corsi Candidato
				m.ListCorsi = ""

				if XDLista.corso01 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[02]) 
				endif
				if XDLista.corso02 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[03]) 
				endif
				if XDLista.corso03 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[04]) 
				endif
				if XDLista.corso04 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[05]) 
				endif
				if XDLista.corso05 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[06]) 
				endif
				if XDLista.corso06 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[07]) 
				endif
				if XDLista.corso07 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[08]) 
				endif
				if XDLista.corso08 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[09]) 
				endif
				if XDLista.corso09 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[10]) 
				endif
				if XDLista.corso10 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[11]) 
				endif
				if XDLista.corso11 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[12]) 
				endif
				if XDLista.corso12 = 1  then
				   m.ListCorsi = m.ListCorsi+ + " | "+alltrim(sis_corso[13]) 
				endif
                select XDLista
                replace XDLista.td_corsi with m.ListCorsi


            *-- Curriculum Candidato
				m.ListCurriculum = ""

				if XDLista.curr01 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[02]) 
				endif
				if XDLista.curr02 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[03]) 
				endif
				if XDLista.curr03 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[04]) 
				endif
				if XDLista.curr04 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[05]) 
				endif
				if XDLista.curr05 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[06]) 
				endif
				if XDLista.curr06 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[07]) 
				endif
				if XDLista.curr07 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[08]) 
				endif
				if XDLista.curr08 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[09]) 
				endif
				if XDLista.curr09 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[10]) 
				endif
				if XDLista.curr10 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[11]) 
				endif
				if XDLista.curr11 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[12]) 
				endif
				if XDLista.curr12 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[13]) 
				endif
				if XDLista.curr13 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[14]) 
				endif
				if XDLista.curr14 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[15]) 
				endif
				if XDLista.curr15 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[16]) 
				endif 
				if XDLista.curr16 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[17]) 
				endif 				
				if XDLista.curr17 = 1  then
				   m.ListCurriculum = m.ListCurriculum + " | "+alltrim(sis_curriculum[18]) 
				endif 				

                select XDLista
                replace XDLista.td_curr with  m.ListCurriculum

				          
         
           *-- Storico 
	            m.zx_matricola = XDLista.matricola
	            if used("czstorico") then
	               select czstorico
	               use
	            endif
	            
	            select * ;
	              from xstorico ;
	             where xstorico.matricola = m.zx_matricola ;
	            order by xstorico.dataasspos asc           ;
	            into cursor czstorico
	            
	            m.zx_indice = 1
	            select czstorico
	            go top
	            
	            scan
	               
	               do case
	                  case m.zx_indice = 1
	                       m.zx_indice = 2
	                       select XDLista
	                       replace XDLista.pse01 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)
	                       
	                  case m.zx_indice = 2
	                       m.zx_indice = 3
	                       select XDLista
	                       replace XDLista.pse02 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 3
	                       m.zx_indice = 4
	                       select XDLista
	                       replace XDLista.pse03 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 4
	                       m.zx_indice = 5
	                       select XDLista
	                       replace XDLista.pse04 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 5
	                       m.zx_indice = 6
	                       select XDLista
	                       replace XDLista.pse05 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 6
	                       m.zx_indice = 7
	                       select XDLista
	                       replace XDLista.pse06 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 7
	                       m.zx_indice = 8
	                       select XDLista
	                       replace XDLista.pse07 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 8
	                       m.zx_indice = 9
	                       select XDLista
	                       replace XDLista.pse08 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 9
	                       m.zx_indice = 10
	                       select XDLista
	                       replace XDLista.pse09 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	                  case m.zx_indice = 10
	                       select XDLista
	                       replace XDLista.pse010 with dtoc(czstorico.dataasspos)+" "+dtoc(czstorico.datacesspo)+": "+alltrim(czstorico.annota)

	               endcase
	            
	               select czstorico
	            endscan 
                 
            
            *-- Ufficio Attuale
				if  upper(alltrim(XDLista.em))=="E" then 
					if XDLista.ntp_rif = 0 then
					   m.zx_sedeadsc = "Sede non presente."
					else
					   if seek(XDLista.ntp_rif,"esede","ntp_ide") then
					      m.zx_sedeadsc =  alltrim(esede.rango)+" - "+alltrim(esede.sede)
					   else
					      m.zx_sedeadsc = "Sede non trovata."
					   endif
					endif   
				else 
				    m.zx_sedeadsc = XDLista.sedea_dsc
				endif 
				select XDLista
				replace XDLista.sede_att with m.zx_sedeadsc
        
           select XDLista
        endscan
        

       
       
   *-- Enrich with Classification
          


    *-- Ordering
            
   *-- Get Totale Sedi
  
   *-- Information Retrival
       
   
          
   *- Ordinamento

   *-- Report Type Selection
       m.xReport="r09_lista_domande_anagrafico_jet.frx"
 	  
  
   *-- Check Information Retrived
	   IF reccount("XDLista") = 0
	      =MESSAGEBOX("Non ci sono informazioni"+CHR(13)+;
	                  "relative a quanto specificato.",  ;
	                  0+64+0,;
	                  "ATTENZIONE !!!" )
	      RETURN
	  ENDIF


  
  *-- Print or Preview Information
      HIDE WINDOW ALL
      SELECT XDLista 
      GO TOP
  
	  DO CASE
	     CASE M.xiVisionType=="PREVIEW"
	          REPORT FORM (M.xReport) ;
	                 ALL              ;
	                 NOCONSOLE        ;
	                 PREVIEW
	                 
	     CASE M.xiVisionType=="PRINT"
	          REPORT FORM (M.xReport) ;
	                 ALL              ;
	                 NOCONSOLE        ;
	                 TO PRINTER PROMPT

	     CASE M.xiVisionType=="EXPORT"
	         SELECT XDLista
             GO TOP
             export to (alltrim(thisform.cache.value)+"\"+m.DynaTitle+"del "+dtoc(date())+".XLS")  type XL5
             
 
              *-- External Service Calling
			      e_hndWindow = 0      && Window Handle
			      e_cAction   = "open" && Action 
			      e_cFileName = (alltrim(thisform.cache.value)+"\"+m.DynaTitle+"del "+dtoc(date())+".XLS")
			      e_cParams   = "c:\@eiter\cache"
			      e_cDir      = ""
			      e_nShowWin  = 1			              
                  =ShellExecute(0,e_cAction,e_cFileName,e_cParams,"",e_nShowWin)   
                        
	  ENDCASE


      
  *-- Garbage Collector for Recycle
      return
	  IF USED("trlist01")
	     SELECT trlist01
	     USE
	  ENDIF
