* Life
*------------+-------------------------------------------------------------------------------------------------------------
* 04/04/1999 | Revised for Decimal Number con tre cifre decimali
*------------+-------------------------------------------------------------------------------------------------------------
  
* SECTION COMMUNICATION
  PARAMETERS M.xnNumber

* SECTION SETTINGS
  SET DECIMALS TO 18
  
* SECTION SERVICE  
  PRIVATE M.Lettere, m.LettereD, m.ParteIntera, m.ParteDecimale
  m.Lettere        = ""
  m.LettereD       = ""
  m.ParteIntera    = 0
  m.ParteDecimale  = 0

* area global intelligence
  m.ParteIntera   = int(m.xnNumber)
  m.ParteDecimale = m.xnNumber - int(m.xnNumber)
  m.ParteDecimale = int(m.ParteDecimale*100)
    
  do case
     case m.ParteDecimale = 0
          M.Lettere = GetNumberToLetter(m.ParteIntera)
          M.Lettere=STRTRAN(M.Lettere,"OO","O")+"/00"  
          
     case m.ParteDecimale > 0
          M.Lettere  = GetNumberToLetter(m.ParteIntera)
          M.Lettere  =STRTRAN(M.Lettere,"OO","O")            
          M.LettereD = GetNumberToLetter(m.ParteDecimale)
          M.LettereD =STRTRAN(M.LettereD,"OO","O")  
          
          m.Lettere  = m.Lettere+"/"+transform(m.ParteDecimale,"@L 99")      
  endcase
  
  RETURN M.Lettere

  
*-------------------------------------------------------------------------------------------------------------------------
function GetNumberToLetter (m.xinNumber)

  local m.NInL
  m.NInL = ""
  DO CASE
     CASE BETWEEN(M.xinNumber,1,100)
          m.NInL= UDConvert(M.xinNumber)
          
     CASE BETWEEN(M.xinNumber,101,999)
          m.NInL= CConvert(M.xinNumber)
          
     CASE BETWEEN(M.xinNumber,1000,999999)
          m.NInL= KConvert(M.xinNumber)
          
     CASE BETWEEN(M.xinNumber,1000000,999999999)
          m.NInL= MConvert(M.xinNumber)
          
     CASE BETWEEN(M.xinNumber,1000000000,999999999999)
          m.NInL= GConvert(M.xinNumber)
  ENDCASE
  m.NInL=STRTRAN(m.NInL,"OO","O")
  
  RETURN m.NInL
endfunc  
*-------------------------------------------------------------------------------------------------------------------------
FUNCTION GConvert

* SECTION COMMUNICATION
  PARAMETERS M.xnG
        
* SECTION SERVICE
  PRIVATE M.nSecond, M.nFirst
  *
  M.nSecond = MOD(M.xnG,1000000000)
  M.nFirst  = INT(M.xnG/1000000000)
  
  
* AREA INTELLIGENCE

  DO CASE
     CASE M.nFirst=1
          RETURN "UNMILIARDO"+MConvert(M.nSecond)
     
     CASE BETWEEN(M.nFirst,2,100)     
          RETURN UDConvert(M.nFirst)+"MILIARDI"+MConvert(M.nSecond)
     
     CASE BETWEEN(M.nFirst,101,999)
          RETURN CConvert(M.nFirst)+"MILIARDI"+MConvert(M.nSecond) 

     OTHERWISE
          RETURN MConvert(M.nSecond)
  ENDCASE  
*
RETURN ""

*-------------------------------------------------------------------------------------------------------------------------
FUNCTION MConvert

* SECTION COMMUNICATION
  PARAMETERS M.xnM
        
* SECTION SERVICE
  PRIVATE M.xcM, M.nSecond, M.nFirst
  *
  M.nSecond = MOD(M.xnM,1000000)
  M.nFirst  = INT(M.xnM/1000000)
  
  
* AREA INTELLIGENCE

  DO CASE
     CASE M.nFirst=1
          RETURN "UNMILIONE"+KConvert(M.nSecond)
     
     CASE BETWEEN(M.nFirst,2,100)
     
          RETURN UDConvert(M.nFirst)+"MILIONI"+KConvert(M.nSecond)
     
     CASE BETWEEN(M.nFirst,101,999)
          RETURN CConvert(M.nFirst)+"MILIONI"+KConvert(M.nSecond) 
     OTHERWISE
          RETURN KConvert(M.nSecond)
  ENDCASE  
*
RETURN ""
*-------------------------------------------------------------------------------------------------------------------------
FUNCTION KConvert

* SECTION COMMUNICATION
  PARAMETERS M.xnM
        
* SECTION SERVICE
  PRIVATE M.xcM, M.nSecond, M.nFirst
  *
  M.nSecond = MOD(M.xnM,1000)
  M.nFirst  = INT(M.xnM/1000)
  
  
* AREA INTELLIGENCE

  DO CASE
     CASE M.nFirst=1
          RETURN "MILLE"+CConvert(M.nSecond)
     CASE BETWEEN(M.nFirst,2,100)
          RETURN UDConvert(M.nFirst)+"MILA"+CConvert(M.nSecond)
     CASE BETWEEN(M.nFirst,101,999)
          RETURN CConvert(M.nFirst)+"MILA"+CConvert(M.nSecond) 
     OTHERWISE
          RETURN CConvert(M.nSecond)
  ENDCASE  
*
RETURN ""
*-------------------------------------------------------------------------------------------------------------------------
FUNCTION CConvert

* SECTION COMMUNICATION
  PARAMETERS M.xnC
  
* SECTION SERVICE
  PRIVATE M.nFirst, M.nSecond
  
  M.nSecond = MOD(M.xnC,100)    
  M.nFirst  = INT(M.xnC/100)
  
* AREA INTELLIGENCE

  DO CASE
     CASE M.nFirst=1
          RETURN "CENTO"+UDConvert(M.nSecond)
          
     CASE BETWEEN(M.nFirst,2,9)
          RETURN UDConvert(M.nFirst)+"CENTO"+UDConvert(M.nSecond)

     OTHERWISE
          RETURN UDConvert(M.nSecond)
          
  ENDCASE  
*
RETURN ""
*-------------------------------------------------------------------------------------------------------------------------
FUNCTION UDConvert

* SECTION COMMUNICATION
  PARAMETERS M.xUD
  
* AREA INTELLIGENCE
  DO CASE
     CASE M.xUD=1
          RETURN "UNO"
     CASE M.xUD=2
          RETURN "DUE"
     CASE M.xUD=3
          RETURN "TRE"
     CASE M.xUD=4
          RETURN "QUATTRO"
     CASE M.xUD=5
          RETURN "CINQUE"
     CASE M.xUD=6
          RETURN "SEI"
     CASE M.xUD=7
          RETURN "SETTE"
     CASE M.xUD=8
          RETURN "OTTO"
     CASE M.xUD=9
          RETURN "NOVE"
     CASE M.xUD=10
          RETURN "DIECI"
     CASE M.xUD=11
          RETURN "UNDICI"
     CASE M.xUD=12
          RETURN "DODICI"
     CASE M.xUD=13
          RETURN "TREDICI"
     CASE M.xUD=14
          RETURN "QUATTORDICI"
     CASE M.xUD=15
          RETURN "QUINDICI"
     CASE M.xUD=16
          RETURN "SEDICI"
     CASE M.xUD=17
          RETURN "DICIASSETTE"
     CASE M.xUD=18
          RETURN "DICIOTTO"
     CASE M.xUD=19
          RETURN "DICIANNOVE"
     CASE M.xUD=20
          RETURN "VENTI"
     CASE M.xUD=21
          RETURN "VENTUNO"
     CASE M.xUD=22
          RETURN "VENTIDUE"
     CASE M.xUD=23
          RETURN "VENTITRE"
     CASE M.xUD=24
          RETURN "VENTIQUATTRO"
     CASE M.xUD=25
          RETURN "VENTICINQUE"
     CASE M.xUD=26
          RETURN "VENTISEI"
     CASE M.xUD=27
          RETURN "VENTISETTE"
     CASE M.xUD=28
          RETURN "VENTOTTO"
     CASE M.xUD=29
          RETURN "VENTINOVE"
     CASE M.xUD=30
          RETURN "TRENTA"
     CASE M.xUD=31
          RETURN "TRENTUNO"
     CASE M.xUD=32
          RETURN "TRENTADUE"
     CASE M.xUD=33
          RETURN "TRENTATRE"
     CASE M.xUD=34
          RETURN "TRENTAQUATTRO"
     CASE M.xUD=35
          RETURN "TRENTACINQUE"
     CASE M.xUD=36
          RETURN "TRENTASEI"
     CASE M.xUD=37
          RETURN "TRENTASETTE"
     CASE M.xUD=38
          RETURN "TRENTOTTO"
     CASE M.xUD=39
          RETURN "TRENTANOVE"
     CASE M.xUD=40
          RETURN "QUARANTA"
     CASE M.xUD=41
          RETURN "QUARANTUNO"
     CASE M.xUD=42
          RETURN "QUARANTADUE"
     CASE M.xUD=43
          RETURN "QUARANTATRE"
     CASE M.xUD=44
          RETURN "QUARANTAQUATTRO"
     CASE M.xUD=45
          RETURN "QUARANTACINQUE"
     CASE M.xUD=46
          RETURN "QUARANTASEI"
     CASE M.xUD=47
          RETURN "QUARANTASETTE"
     CASE M.xUD=48
          RETURN "QUARANTOTTO"
     CASE M.xUD=49
          RETURN "QUARANTANOVE"
     CASE M.xUD=50
          RETURN "CINQUANTA"
     CASE M.xUD=51
          RETURN "CINQUANTUNO"
     CASE M.xUD=52
          RETURN "CINQUANTADUE"
     CASE M.xUD=53
          RETURN "CINQUANTATRE"
     CASE M.xUD=54
          RETURN "CINQUANTAQUATTRO"
     CASE M.xUD=55
          RETURN "CINQUANTACINQUE"
     CASE M.xUD=56
          RETURN "CINQUANTASEI"
     CASE M.xUD=57
          RETURN "CINQUANTASETTE"
     CASE M.xUD=58
          RETURN "CINQUANTOTTO"
     CASE M.xUD=59
          RETURN "CINQUANTANOVE"
     CASE M.xUD=60
          RETURN "SESSANTA"
     CASE M.xUD=61
          RETURN "SESSANTUNO"
     CASE M.xUD=62
          RETURN "SESSANTADUE"
     CASE M.xUD=63
          RETURN "SESSANTATRE"
     CASE M.xUD=64
          RETURN "SESSANTAQUATTRO"
     CASE M.xUD=65
          RETURN "SESSANTACINQUE"
     CASE M.xUD=66
          RETURN "SESSANTASEI"
     CASE M.xUD=67
          RETURN "SESSANTASETTE"
     CASE M.xUD=68
          RETURN "SESSANTOTTO"
     CASE M.xUD=69
          RETURN "SESSANTANOVE"
     CASE M.xUD=70
          RETURN "SETTANTA"
     CASE M.xUD=71
          RETURN "SETTANTUNO"
     CASE M.xUD=72
          RETURN "SETTANTADUE"
     CASE M.xUD=73
          RETURN "SETTANTATRE"
     CASE M.xUD=74
          RETURN "SETTANTAQUATTRO"
     CASE M.xUD=75
          RETURN "SETTANTACINQUE"
     CASE M.xUD=76
          RETURN "SETTANTASEI"
     CASE M.xUD=77
          RETURN "SETTANTASETTE"
     CASE M.xUD=78
          RETURN "SETTANTOTTO"
     CASE M.xUD=79
          RETURN "SETTANTANOVE"
     CASE M.xUD=80
          RETURN "OTTANTA"
     CASE M.xUD=81
          RETURN "OTTANTUNO"
     CASE M.xUD=82
          RETURN "OTTANTADUE"
     CASE M.xUD=83
          RETURN "OTTANTATRE"
     CASE M.xUD=84
          RETURN "OTTANTAQUATTRO"
     CASE M.xUD=85
          RETURN "OTTANTACINQUE"
     CASE M.xUD=86
          RETURN "OTTANTASEI"
     CASE M.xUD=87
          RETURN "OTTANTASETTE"
     CASE M.xUD=88
          RETURN "OTTANTOTTO"
     CASE M.xUD=89
          RETURN "OTTANTANOVE"
     CASE M.xUD=90
          RETURN "NOVANTA"
     CASE M.xUD=91
          RETURN "NOVANTUNO"
     CASE M.xUD=92
          RETURN "NOVANTADUE"
     CASE M.xUD=93
          RETURN "NOVANTATRE"
     CASE M.xUD=94
          RETURN "NOVANTAQUATTRO"
     CASE M.xUD=95
          RETURN "NOVANTACINQUE"
     CASE M.xUD=96
          RETURN "NOVANTASEI"
     CASE M.xUD=97
          RETURN "NOVANTASETTE"
     CASE M.xUD=98
          RETURN "NOVANTOTTO"
     CASE M.xUD=99
          RETURN "NOVANTANOVE"
     CASE M.xUD=100
          RETURN "CENTO"
          
  ENDCASE  
*
RETURN ""
*-------------------------------------------------------------------------------------------------------------------------
